function TableSection(id, ref)
{
    Section.call(this, id, ref);
    if(ref && typeof util != "undefined")
        this.sP = util.getNode(ref, "section", { id: id });
    this.aux.isExp = false; // true, wenn diese Tabelle das Ausklappen versteckter Spalten untersttzt
}

TableSection.prototype = new Section();


TableSection.prototype.evalRows = function evalRows(dObj)
{
    if(typeof this.sP == "undefined")
        return null;

    var sP = this.sP;
    var colCount = dObj.dV.length;

    // DOM node:
    var cObj = null, cCell = null, col = null;
    try
    {
        switch(dObj.type)
        {
            case cc.cnst.dtp_tabHdr:
                // Action an TableSection? D.h. alle Zellen lassen sich klicken
                var globalAction = dObj.aux[cc.cnst.aux_action];
                if(globalAction)
                {
                    util.registerCE(this.sP, "click", { fn: [util.createFN(globalAction)] });
                }
                // Manchmal ist ein Page-Parameter dabei
                this.aux.defaultChangeAction = dObj.aux[cc.cnst.aux_page] ? ["Change", dObj.aux[cc.cnst.aux_page], "value", "value", "value"] : ["Change", "value", "value", "value"];
                var f = util.createFN(this.aux.defaultChangeAction);
                util.registerCE(this.sP, "enter", ({ fn: f }));
                util.registerCE(this.sP, "change", ({ fn: f }));
                //var _this = this;
                //util.appendCE(this.id, "click", { fn: function(cObj) { _this.toggleDetailsTableData(cObj); } });

                // 
                var css = dObj.aux[cc.cnst.aux_css] || "";
                var isScrollable = css.indexOf("scrollable") > -1;
                if(isScrollable)
                    css.replace(/ scrollable/,"");
                this.aux.tableCss = css;

                // this.aux.head referenziert thead:
                this.aux.head = util.getNode(sP, null, { css: "thead" + (globalAction ? " interActive" : "") });
                // this.aux.body referenziert tbody:
                this.aux.body = util.getNode(sP, null, { css: "tbody" + (globalAction ? " interActive" : "") + (isScrollable ? " scrollable" : "") });

                this.aux.col = new Array(colCount);
                this.aux.colNames = new Array(colCount);
                var prioArr = new Array(colCount);
                for(var j = 0; j < colCount; j++)
                {
                    var dV = dObj.dV[j];

                    // RAC: kein more-Button-Feature
                    //if (dV.aux.prio > -1 && !this.aux.isExp)
                    //{
                    //    this.aux.isExp = true;
                    //}
                    dV.aux.prio = 0;

                    col = this.aux.col[j] = {};
                    col.id = dV.id; // wer braucht das "dV.aux[cc.cnst.aux_name] || "???
                    this.aux.colNames[col.id] = j;
                    col.name = dV.aux[cc.cnst.aux_name] || "";
                    col.title = dV.aux[cc.cnst.aux_title] || dV.value || "";
                    col.flexGrow = dV.aux[cc.cnst.aux_flexGrow] || "";
                    col.align = dV.aux[cc.cnst.aux_align] ? " algn" + dV.aux[cc.cnst.aux_align] : "";
                    col.width = parseInt(dV.aux[cc.cnst.aux_width]);
                    col.maxWidth = parseInt(dV.aux[cc.cnst.aux_maxWidth]) || -1;
                    col.dtp = dV.aux[cc.cnst.aux_dtp];
                    col.addTxt = dV.aux[cc.cnst.aux_addTxt];
                    col.css = dV.aux[cc.cnst.aux_css];
                    if(dV.aux[cc.cnst.aux_img])
                    {
                        col.img = dV.aux[cc.cnst.aux_img];
                         col.height = dV.aux[cc.cnst.aux_height];
                    }
                    col.sortAction = dV.aux[cc.cnst.aux_sort];
                    col.sortOrder = dV.aux[cc.cnst.aux_order];
                    col.prio = dV.aux[cc.cnst.aux_prio] ? parseInt(dV.aux[cc.cnst.aux_prio]) : j;
                    prioArr[j] = { prio: parseInt(dV.aux[cc.cnst.aux_prio]), width: col.width };
                }
                if (this.aux.isExp)
                {
                    prioArr.sort(function (c1, c2) { return c1.prio - c2.prio; });
                    var wSum = this.aux.breakPoints = {};
                    for (var j = 0; j < colCount; j++)
                    {
                        col = prioArr[j];
                        key = "tab" + col.prio;
                        if (j == 0)
                            wSum[key] = 0;
                        else if (col.prio != prioArr[j - 1].prio)
                            wSum[key] = wSum["tab" + prioArr[j - 1].prio];
                        wSum[key] += col.width;
                    }
                    // Mindestbreite verankern:
                    this.sP.style.minWidth = (this.aux.breakPoints["tab0"] + 14 + 25) + "px";
                }
                else
                    this.sP.className = util.getClassList("flexTbl", this.aux.tableCss);

                if(!dObj.visible)
                    break;
            case cc.cnst.dtp_tabRow:
                // Zeile fllen
                var rId = util.getId(this.id, dObj.id);

                // update?
                var cIdx = dObj.aux[cc.cnst.aux_updateCol];
                if(cIdx == null)
                {
                    // manchmal entspricht eine optische Zeile 2 physischen Zeilen
                    var continueRow = (typeof dObj.aux[cc.cnst.aux_continue] != "undefined");

                    var pN = { id: rId, css: "tr" };

                    // Fr pseudo-berschriften:
                    var css = dObj.aux[cc.cnst.aux_css];
                    if(css)
                    {
                        util.joinClass(pN, css);
                        if(cc.cnst.dtp_tabHdr.toLowerCase() != css)
                            util.joinClass(pN, dObj.type.toLowerCase()); // Type als css extra
                    }
                    else
                        util.joinClass(pN, dObj.type.toLowerCase()); // Type als css

                    // 
                    cRow = util.getNode((dObj.type == cc.cnst.dtp_tabHdr?this.aux.head: this.aux.body), null, pN);
                    //util.attachEvt("activate", cRow, catchEvent)
                    if(continueRow)
                    {
                        var jArr = this.aux.joined || {};
                        if(jArr[rId] == null)
                        {
                            // Originalzeile ohne continue
                            jArr[rId] = [cRow];
                        }

                        // continue-Zeile mit Idx
                        var jIdx = jArr[rId].length;
                        pN.id += util.rIdxDlm + jIdx;
                        util.addClass("addRow", jArr[rId][jIdx - 1]);
                        cRow = util.getNode(this.aux.body, null, pN);
                        jArr[rId][jIdx] = cRow;
                        jArr[cRow.id] = jArr[rId]; // Verweis auf root-Zeile
                        this.aux.joined = jArr;
                    }

                    // Selektierte Zeile markieren (Highlander) bzw. zurcksetzen
                    if(dObj.selected || (this.aux.mark1 && cRow === this.aux.mark1[0]))
                        this.handleRowSelection(cRow, dObj.selected);

                    var spanningCols = -1;

                    for (var j = 0; j < colCount; j++)
                    {
                        var dV = dObj.dV[j];
                        var col = this.aux.col[j];
                        var dVId = util.getId(cRow.id, col.id);

                        // Skip: die Breite dieser Spalte wird der vorherigen Zelle zugeschlagen
                        if (spanningCols > -1 || dV.aux[cc.cnst.aux_skip])
                        {
                            if (cCell)
                            {
                                cCell.style.width = (parseInt(cCell.style.width) + col.width) + "px";
                                if (col.flexGrow)
                                {
                                    cCell.style.flexGrow = col.flexGrow;
                                    cCell.style.msFlexPositive = col.flexGrow;
                                    cCell.style.webkitFlexGrow = col.flexGrow;
                                }
                            }
                            if (spanningCols > -1)
                                spanningCols--;
                            continue;
                        }

                        // colspan
                        if (dV.aux[cc.cnst.aux_colspan] && dV.aux[cc.cnst.aux_colspan] != cc.cnst.aux_fullSpan)
                        {
                            util.joinClass(pN, "colSpan" + dV.aux[cc.cnst.aux_colspan]);
                            spanningCols = --dV.aux[cc.cnst.aux_colspan];
                        }

                        var cTT = dV.aux[cc.cnst.aux_tt];
                        cObj = document.getElementById(dVId); // control

                        var colType = dV.aux[cc.cnst.aux_dtp] || col.dtp || cc.cnst.dtp_txt;
                        pN = { css: dObj.type == cc.cnst.dtp_tabHdr ? "th" : "td" };
                        util.joinClass(pN, col.name);
                        util.joinClass(pN, dV.aux[cc.cnst.aux_align] ? " algn" + dV.aux[cc.cnst.aux_align] : col.align);
                        if (this.aux.isExp)
                            util.joinClass(pN, "prio" + col.prio);
                        util.joinClass(pN, dV.aux[cc.cnst.aux_css]);

                        // Zelle selectable?
                        if (typeof dV.aux[cc.cnst.aux_selected] != "undefined")
                        {
                            colType = cc.cnst.dtp_chk;
                            dV.selected = dV.aux[cc.cnst.aux_selected] == "true";
                        }

                        if (cTT)
                            pN.title = cTT;

                        // Zelle in Kopf- oder Tabellenzeile (ohne verbundene Zellen!):
                        cCell = cRow.childNodes.length > j ? cRow.childNodes[j] : util.getNode(cRow, null, pN);

                        if (dObj.type == cc.cnst.dtp_tabHdr)
                        {
                            if (col.sortAction)
                            {
                                if (col.sortOrder)
                                    util.addClass(col.sortOrder + "Order", cCell);
                                cObj = util.getNode(cCell, "a", { id: dVId });
                                util.registerCE(dVId, "click", { ce: col.sortAction });
                            }
                            else
                                cObj = util.getNode(cCell, "span", { id: dVId });
                            cObj.innerHTML = dV.value;
                        }
                        else
                        {
                            //
                            this.handleCellContent(cCell, dV, dVId, cObj, colType, col, dObj.aux);

                            // Falls eine Action mitkommt, unabhngig von der Darstellung ber die Id zuordnen
                            // (nicht fr ext. Links!)
                            // input -> "change" statt "click"
                            if (dV.aux[cc.cnst.aux_action] && !dV.aux[cc.cnst.aux_target])
                                util.registerCE(dVId, (colType == cc.cnst.dtp_inp ? "change" : "click"), { ce: dV.aux[cc.cnst.aux_action] });
                            /* Hat die Spalte keine eigene Action, selektiert ein Radiobutton die Zeile
                            if(colType == cc.cnst.dtp_radio && dObj.aux[cc.cnst.aux_action])
                            util.registerCE(cRow.id, "click", { ce: dObj.aux[cc.cnst.aux_action] });*/
                        }
                        // Trennzeile
                        if (dV.aux[cc.cnst.aux_colspan] == cc.cnst.aux_fullSpan)
                        {
                            util.addClass("fullSpan", cCell);
                            return;
                        }


                        // nur, falls das Feature aktiv ist:
                        if (this.aux.isExp)
                        {
                            if (dObj.type == cc.cnst.dtp_tabRow && col.title)
                                cCell.setAttribute("data-title", col.title + ":");
                        }
                        if (col.flexGrow)
                        {
                            cCell.style.flexGrow = col.flexGrow;
                            cCell.style.msFlexPositive = col.flexGrow;
                            cCell.style.webkitFlexGrow = col.flexGrow;
                        }
                        cCell.style.width = col.width + "px";
                        if (col.maxWidth > -1)
                            cCell.style.maxWidth = col.maxWidth + "px";
                    }

                    //Link more Information?
                    if(colCount > 0 && this.aux.isExp && !util.hasClass("moreInfo", cRow.childNodes[colCount - 1]))
                    {
                        if(dObj.type == cc.cnst.dtp_tabHdr)
                            util.addNode(cRow, "div", { css: "th moreInfo" });
                        else
                        {
                            var moreInfo = util.addNode(cRow, "div", { id: util.getId(this.id, dObj.id, "more"), css: "td moreInfo" });
                            util.addNode(moreInfo, "a");
                            if("Tabrow" == dObj.type)
                            {
                                var _this = this;
                                var _cRow = cRow;
                                util.registerCE(moreInfo.id, "click", { fn: function (cObj) { _this.toggleDetailsTableData(cObj); } });
                            }
                        }
                    }
                }
                else
                {
                    // row continue index:
                    var rcIdx = dObj.aux[cc.cnst.aux_rowContinue_idx];
                    if(rcIdx)
                        rId += util.rIdxDlm + jArr[dObj.id][jIdx].id;

                    // col index per Name or index?
                    col = this.aux.col[this.aux.colNames[cIdx]] || this.aux.col[cIdx];
                    var dVId = util.getId(rId, col.id);

                    cObj = document.getElementById(dVId);
                    if(cObj)
                        cCell = util.hasClass("td", cObj) ? cObj : cObj.parentNode;
                    else if(cRow.childNodes.length > cIdx)
                    {
                        cCell = cRow.childNodes[cIdx];
                        cObj = cCell.firstChild;
                    }
                    util.addClass(dObj.aux[cc.cnst.aux_css], cCell);
                    util.evictClass(dObj.aux[cc.cnst.aux_cssClear], cCell);

                    var colType = dObj.aux[cc.cnst.aux_dtp];

                    // Zelle selectable?
                    if (typeof dObj.aux[cc.cnst.aux_selected] != "undefined")
                    {
                        colType = cc.cnst.dtp_chk;
                        dObj.selected = dObj.aux[cc.cnst.aux_selected] == "true";
                    }

                    if (colType)
                    {
                        // Zelltyp hat sich gendert?
                        if(cCell.getAttribute("data-type") != colType.toLowerCase())
                        {
                            util.recRemove(cCell);
                            cObj = null;
                        }
                        var cAux = {};
                        cAux[cc.cnst.aux_img] = dObj.aux[cc.cnst.aux_img];
                        this.handleCellContent(cCell, { value: dObj.desc, selected: dObj.selected, aux: cAux }, dVId, cObj, colType, col, dObj.aux);
                    }
                }
                break;
        }
    } catch(ex) { this.trace("error", "evalData()", dObj.id + ": " + ex.stack); }
    return cObj;
}
TableSection.prototype.finalize = function ()
{
    if (!this.aux.isExp)
        return false;

    // fr die Tabelle overflow-Bedingungen am parentNode setzen
    //util.addClass("confined", this.sP.parentNode);

    // fr Resize letzte Restriction entfernen:
    //this.trace("error", "finalize()", this.sP.className + ":" + this.sP.parentNode.offsetWidth);
    this.sP.className = this.aux.tableCss;
    //this.trace("error", "finalize()", this.sP.className + ":" + this.sP.parentNode.offsetWidth);

    var pW = this.sP.parentNode.offsetWidth; // > 0 ? this.sP.parentNode.offsetWidth - this.sP.offsetWidth : 0;
    if (this.aux.isExp && pW > 0)
    {
        var lastKey = "tab0";
        // more-Button???
        var wMax = pW - (14 + 25 + 10); // margins + moreInf-Button(?)
        // walk over priorities:
        for (var key in this.aux.breakPoints)
        {
            if (this.aux.breakPoints[key] > wMax)
            {
                util.addClass(lastKey, this.sP); // visible cols
                util.addClass("more", this.sP); // visible More button
                break;
            }
            lastKey = key;
        }
        //this.trace("error", "finalize()", this.sP.className + "(" + pW + "/ " + wMax + " < " + this.aux.breakPoints[key] + ")");
        util.addClass("flexTbl", this.sP);
        // Test, ob es passt?
    }
    else
    {
        util.addClass("table", this.sP);
        //if(!this.sP.style.minWidth)
        //    this.sP.style.minWidth = this.aux.minWidth + "px";//this.sP.childNodes[0].getBoundingClientRect()
    }
    //this.trace("error", "finalize()", this.sP.className);
};

TableSection.prototype.toggleDetailsTableData = function toggleDetailsTableData(toggleElement)
{
    // moreInfo-Button?
    if(!util.hasClass("moreInfo", toggleElement))
        return;
    while(!util.hasClass("tr", toggleElement))
        toggleElement = toggleElement.parentNode;

    //Status geklicktes Element ermitteln
    var isOpen = util.hasClass("show", toggleElement);

    //bereits geoeffnetes "tapForMoreInformation" schliessen, gibt max. eins:
    //aktuelle geklickte oder ein anderes offenes sowie dessen Text anpassen 
    if(this.aux.openDetailsRow)
    {
        util.removeClass("show", this.aux.openDetailsRow);
        this.aux.openDetailsRow = null;
    }
    //falls das geklickte, noch nicht offen war -> jetzt oeffnen plus Text anpassen
    if(!isOpen)
    {
        this.aux.openDetailsRow = toggleElement;
        util.addClass("show", toggleElement);

        //action
        if(cc.cntrls[this.id] && cc.cntrls[this.id]["click"])
            cc.cntrls[this.id]["click"][0](toggleElement, null);
    }
    cc.adjustDimensions(this.id);
}
TableSection.prototype.resize = function ()
{
    this.finalize();
}

TableSection.prototype.handleCellContent = function (cCell, dV, dVId, cObj, colType, col, aux)
{
    // der konkrete Type ist unabhngig von der Spaltendefinition und wird deshalb an der Zelle gehalten
    cCell.setAttribute("data-type", colType.toLowerCase());
    var isDisabled = (typeof dV.aux[cc.cnst.aux_disabled] != "undefined" || typeof aux[cc.cnst.aux_disabled] != "undefined");

    // Zelle deaktivieren?
    util.toggleClass("disabled", cCell, isDisabled);

    var s = null;
    switch(colType)
    {
        case cc.cnst.dtp_chk:
            pN = { id: dVId, type: "checkbox" };
            cObj = util.getNode(cCell, "input", pN);

            cObj.checked = dV.selected;

            // Test: Version update dialog
            if (typeof dV.aux[cc.cnst.aux_disabled] != "undefined" || cObj.disabled)
                this.checkChangeability(null, cObj, false);

            // Checkbox mit Label in einer Zelle
            if (dV.value && dV.value.length > 1)
            {
                if (cCell.childNodes.length == 1)
                {
                    util.getNode(cCell, "label", {}).innerHTML = dV.value;
                    util.addClass("selectableAtt", cCell);
                }
            }
            break;
        case cc.cnst.dtp_radio:
            // setAttribute() zieht nicht im update-Fall (???)
            if(cObj && dV.selected)
                cObj.checked = "checked";
            else
            {
                // RadioButton name 1x/Table
                pN = { id: dVId, type: "radio", name: util.getId("Radio", this.id) };
                if(dV.selected)
                    pN.checked = "checked";
                cObj = util.getNode(cCell, "input", pN);
            }
            break;
        case cc.cnst.dtp_inp:
            if (cObj)
                cObj.value = dV.value;
            else
                cObj = util.getNode(cCell, "input", { id: dVId, type: "text", value: dV.value });

            // wenn die Werte verschieden sind -> isModified
            cObj.defaultValue = cObj.value;

            // bekommt das neue Feld den Focus?
            checkFocus(cObj);
            break;
        case cc.cnst.dtp_img:
            pN = { id: dVId }
            s = dV.aux[cc.cnst.aux_top];
            if(s)// && col.img)
            {
                cObj = util.getNode(cCell, "div", pN);
                // Left ist 0 und top muss negativ sein!!!
                cObj.style.backgroundPosition = "0px -" + s + "px";
                cObj.style.backgroundImage = "url('" + (dV.aux[cc.cnst.aux_img] || col.img) + "')";
                //s = dV.aux[cc.cnst.aux_width];
                //if(s) 
                //cObj.style.width = "100%";// s + "px";
                s = col.height || dV.aux[cc.cnst.aux_height];
                if(s) cObj.style.height = s + "px";
            }
            else
            {
                s = dV.aux[cc.cnst.aux_img]; // || col.img;
                // no source -> no img!
                if(s && (s=s.trim()))
                {
                    pN.src = s;
                    cObj = util.getNode(cCell, "img", pN);
                    s = dV.aux[cc.cnst.aux_width];
                    if(s) cObj.style.width = s + "px";
                    s = dV.aux[cc.cnst.aux_height];
                    if(s) cObj.style.height = s + "px";
                }
            }
            break;
        case cc.cnst.dtp_action:
            // im update-Fall nur den Text bernehmen (Action kommt nicht nochmal!)
            if(cObj)
            {
                cObj.innerHTML = dV.value;
                util.evictClass(dV.aux[cc.cnst.aux_cssClear], cObj);
            }
            // initial wird uterschieden: wenn Action, dann Link, sonst span
            else
            {
                if(dV.aux[cc.cnst.aux_action])
                {
                    var pN = { id: dVId };
                    util.joinClass(pN, (col.css || dV.aux[cc.cnst.aux_css]));
                    if(dV.aux[cc.cnst.aux_target])
                    {
                        pN.href = dV.aux[cc.cnst.aux_action];
                        pN.target = dV.aux[cc.cnst.aux_target];
                    }
                    /*else
                    util.registerCE(pN.id, "click", { ce: dV.aux[cc.cnst.aux_action] });*/
                    cObj = util.getNode(cCell, "a", pN);

                    // "append text"-Feature:
                    if(col.addTxt)
                        cObj.setAttribute("data-addTxt", col.addTxt);

                    s = dV.aux[cc.cnst.aux_img];
                    if(s)
                    {
                        cObj = cObj.childNodes.length > 0 ? cObj.childNodes[0] : util.addNode(cObj, "img", { src: s });
                    }
                    else
                    {
                        cObj.innerHTML = dV.value;
                    }
                }
                else
                {
                    // Inhalt hat keine Action -> kein unterstrichener Link
                    cCell.setAttribute("data-type", cc.cnst.dtp_txt.toLowerCase());
                    (cObj = util.getNode(cCell, "span", { id: dVId })).innerHTML = dV.value;
                }
            }
            break;
        case cc.cnst.dtp_txt:
            cObj = util.getNode(cCell, "span", { id: dVId })

            // Update + null ndert den Anzeigewert nicht!
            if(dV.value != null)
            {
                cObj.innerHTML = dV.value;
                // suspended mode? Falls die Kriterien nicht reichen, "underline" als css am dV anfordern!
                if(dV.value && col.dtp == cc.cnst.dtp_action && util.hasClass("suspended", cCell.parentNode))
                    util.toggleClass("a", cObj, true);
            }
            break;
        case cc.cnst.dtp_txtBox:
            pN = { id: dVId };
            if (dV.aux[cc.cnst.aux_rowCount])
                pN.rows = dV.aux[cc.cnst.aux_rowCount];
            if (!cObj)
                cObj = util.getNode(cCell, "textarea", pN);
            cObj.innerHTML = dV.value;

            // wenn die Werte verschieden sind -> isModified
            cObj.defaultValue = cObj.value;

            // bekommt das neue Feld den Focus?
            checkFocus(cObj);
            break;
        case cc.cnst.dtp_combo:
            // Platzhalter fr Combobox vorbereiten
            var childId = dV.aux[cc.cnst.aux_childId] || aux[cc.cnst.aux_childId];
            if(childId && this.aux.childObjects && this.aux.childObjects[childId])
            {
                pN = { id: dVId, val: dV.value };
                if(isDisabled)
                    pN.disabled = true;
                this.evalSelect(cCell, this.aux.childObjects[childId], pN, cObj);
            }

            break;
        case cc.cnst.dtp_unknown: break;
        default:
            this.trace("error", "evalData()", "Not evaluateted: " + colType + " ( " + dVId + ")");
            break;
    }
    if (cObj)
    {
        // disabled?
        this.checkChangeability(null, cObj, !isDisabled);
    }
}

// CB in Tabellenzelle: DO muss zwischen TabHdr und TabRows kommen
TableSection.prototype.evalSelect = function (sP, dObj, cbItem, cObj)
{
    // Aufruf aus evalData(): DO nur registrieren
    if(sP == this.sP)
    {
        if(!this.aux.childObjects)
            this.aux.childObjects = {};
        this.aux.childObjects[dObj.id] = dObj;
        return;
    }

    // Aufruf this.handleCellContent():
    // Cbx bauen mit registriertem cbDO und id/value der Tabellenzelle
    var cId = cbItem.id;
    var pN = {};

    if(!cObj)
    {
        pN = { id: cId };
        util.joinClass(pN, dObj.aux[cc.cnst.aux_css]);
        sP = this.evalTT(sP, dObj);
        cObj = util.addNode(sP, "select", pN);
    }
    else
    {
        // remove old entries
        cObj.options.length = 0;
    }
    var domValues = dObj.dV;
    if (domValues.length > 0)
    {
        // add new entries
        for(var j = 0; j < domValues.length; j++)
        {
            var domVal = domValues[j];
            util.addNode(cObj, "OPTION", {value:domVal.id, text: domVal.value, selected:domVal.id == cbItem.val});
        }
    }
    // disabled?
    this.checkChangeability(null, cObj, domValues.length > 0 && typeof cbItem.disabled == "undefined");

    util.registerCE(cObj.id, "change", (cObj.disabled ? null : { ce: (dObj.aux[cc.cnst.aux_action] || this.aux.defaultChangeAction) }));
    return null;
};
TableSection.prototype.handleRowSelection = function (cRow, toggleOn)
{
    var rows = this.aux.mark1;
    if(rows)
    {
        for(var i = 0; i < rows.length; i++)
            util.toggleClass(cc.cnst.CSS_SELECTIONMARK1, rows[i], false);
    }
    if(!toggleOn)
        this.aux.mark1 = null;
    else
    {
        rows = this.aux.mark1 = (this.aux.joined && this.aux.joined[cRow.id]) || [cRow];
        for(var i = 0; i < rows.length; i++)
            util.toggleClass(cc.cnst.CSS_SELECTIONMARK1, rows[i], true);
    }
    // wenn nach dem "Umdingsen" eine offene Zeile nicht markiert ist, dann zu, sonst offen lassen!
    if(this.aux.openDetailsRow && !util.hasClass(cc.cnst.CSS_SELECTIONMARK1, this.aux.openDetailsRow))
    {
        util.toggleClass("show", this.aux.openDetailsRow, false);
        this.aux.openDetailsRow = null;
    }
}