﻿var NodeStatus = { init: 1, load: 2, reset: 4, del: 8 };
function NativeNode()
{
    this.init = function ()
    {
        this.parentTree.nodeList[this.id] = this;
        this.nL = this.pNode.nL + 1;
        this.offset = this.pNode.offset.slice(0); 
        //cc.traceError("init()",this.id + ": " + this.nL + " - " + this.offset.length);

        this.setNodeDraw(); 

        // Einrückung + 1:
        if(this.nL > 0)
            this.offset[this.offset.length] = "b"; 

        return this;
    };
    this.setState = function (isOpen)
    {
        this.isOpen = isOpen;

        // Node ändert den Öffnungszustand
        util.toggleClass("of", this.nObj, this.isOpen);
        util.toggleClass("cf", this.nObj, this.isF && !this.isOpen);

        // an den Kindern ändert sich die Sichtbarkeit
        for(var i = 0; i < this.nC; i++)
            this.c[i].toggleVisibility(this.isOpen);
    }

    this.addChild = function (c)
    {
        c.idx = this.nC; // die Kinder kommen der Reihe nach dazu(?)
        this.c[this.nC] = c;
        this.nC = this.c.length;
        return c;
    };
    // Knoten ein- und ausblenden
    // Kinder einblenden, wenn der Knoten offen ist
    // Kinder ausblenden, wenn Vater nicht sichtbar ist (?)
    this.toggleVisibility = function (vis)
    {
        this.nObj.style.display = vis ? "block" : "none";
        if(!vis || this.isOpen)
            for(var i = 0; i < this.nC; i++)
                this.c[i].toggleVisibility(vis);
    };
    this.toggleVisibleData = function (v)
    {
        if(this.isActive)
        {
            this.hasVisibleData = util.toggleClass("open", this.nObj, v);
        }
    }

    // DOM Object anlegen
    this.setNodeDraw = function ()
    {
        var nObj = document.createElement("DIV");
        var pN = { id: "N" + this.id, css: "node " + (this.isOpen ? " of" :this.isF?" cf": "") };
        if(this.aux[cc.cnst.aux_nodeType])
            pN["data-type"] = this.aux[cc.cnst.aux_nodeType];
        util.applyAttrList(nObj, pN);
        
        var flexWrapper = util.addNode(nObj, "div", { css: "wrpFlex" });

        if(this.pNode)
        {
            this.parentTree.container.insertBefore(nObj, this.idx == 0 ? this.pNode.nObj.nextSibling : this.pNode.c[this.idx-1].nObj.nextSibling);
        }
        else
        {
            cc.traceError("setNodeDraw()", this.id + "?");
            this.parentTree.container.appendChild(nObj);
        }

        // offset-Zellen:
        for(var i = 0; i < this.offset.length; i++)
            util.addNode(flexWrapper, "DIV", { css: "offset" });

        //  Abzweig (Aussehen richtet sich nur nach node-Css-Klassen!):
        util.getNode(util.addNode(flexWrapper, "DIV", { css: "tI" }), "SPAN", {});

        //  Bild für Kontextmenü
        if(this.aux.contextMenu)
        {
            util.getNode(util.addNode(flexWrapper, "DIV", { css: "mI" }), "span", { css: "" });
        }

        // Type und Status des Knotens
        pN = { css: "nI" };
        if(this.aux[cc.cnst.aux_status])
            util.joinClass(pN, "status" + this.aux[cc.cnst.aux_status]);
        this.fDiv = util.getNode(util.addNode(flexWrapper, "DIV", pN), "span", null);

        //  Text bzw. Control
        var cell = util.addNode(flexWrapper, "DIV", { css: "desc" });
        // offsets + tI + (mI + nI *2) + .5, wenn zusätzliche Status-Breite
        var lw = this.offset.length + 1 + (2 * 2);
        if(this.aux[cc.cnst.aux_status]) lw += 0.5;
        cell.style.width = "calc(100% - " + (lw) + "rem)";
        cell.innerHTML = this.desc;

        //  DataContainer
        if(this.aux[cc.cnst.aux_childId])
        {
            cell = util.addNode(nObj, "DIV", { css: "nCont" });
            cc.addAnchorCntrl(this.parentTree.context, this.aux[cc.cnst.aux_childId].toString(), cell);
        }
        this.nObj = nObj;
    };
    this.addAuxiliary = function (key, value)
    {
        this.aux[key] = value;
    }
}
function Node(_desc, _id, _icon)
{
    this.id = _id;
    this.desc = _desc;
    this.icon = _icon;
    this.tmDiv = null;
    this.nodeImg = null;
//    this.idx = -1;
    this.isOpen = false;
    this.isActive = false;
    this.hasVisibleData = false;
    this.c = new Array();
    this.nC = 0;
    this.offset = new Array();
    this.nL = 0;
    this.pNode = 0;
    this.state = NodeStatus.init;
    this.isF = true;
    this.nObj = null;
    this.aux = new Array();
}
Node.prototype = new NativeNode();

function Tree(p, sId, context)
{
    this.ID_DUMMY = "@@_0"
    this.ID_ROOT = "A_0"
    this.sIdent = sId;
    this.context = context;
    this.container = p || document.body;
    this.rootId = util.getId(sId, this.ID_ROOT);
    this.nodeList = new Array();
    //this.cN = null;
    this.cL = null;
    this.openEmptyFolders = false;
    this.nodeTypes = {};

    this.setArrowIcon = function (key)
    {
        if(this.cL)
        {
            this.cL.isActive = util.toggleClass("mark1", this.cL.nObj, false);
            this.cL.toggleVisibleData(false);
        }
        this.cL = this.getJSNode(key);
        if(this.cL && this.cL.id != this.ID_ROOT)
        {
            this.cL.isActive = util.toggleClass("mark1", this.cL.nObj, true);
            this.cL.toggleVisibleData(true);
        }
//        else
//        {
//            this.cN = null;
//        }
        return true;
    }

    this.clickNode = function (n)
    {
        try
        {
            var cF = typeof (n) == "string" ? this.nodeList[n] : n;
            if(cF == null)
                cF = this.createJSNode(n);

            var revState = !cF.isOpen;

            if(revState)
            {
                if(cF.state != NodeStatus.load)
                {
                    if(cF.nC == 0)
                    {
                        //this.cN = cF;
                        this.doGetChildren(cF.id);
                        return false;
                    }
                    if(cF.nC > 0)
                    {
                        if(cF.c[0].id != this.ID_DUMMY)
                        {
                            for(var i = 0; i < cF.nC; i++)
                            {
                                cF.c[i].pNode = cF;
                                cF.c[i].idx = i;
                                cF.c[i].init();
                            }
                        }
                        cF.state = NodeStatus.load;
                    }
                }
            }
            cF.setState(revState);
        } catch(ex) { cc.traceError("clickNode()", ex.message); }
        return true;
    }

    this.getJSNode = function (key)
    {
        var cF = this.nodeList[key];
        if(cF)
            return cF;
        else
            return this.createJSNode(key);
    }
    this.createJSNode = function (key)
    {
        return null;
    }
    this.delNode = function (cF)
    {
        if(cF)
        {
            for(var i = 0; i < cF.nC; i++)
            {
                var c = cF.c[i];
                // wenn c nicht schon auf del gesetzt wurde, übernimmt es den state vom Vater
                if((c.state & NodeStatus.del) == 0)
                    c.state = cF.state;
                this.delNode(c);
            }
            cF.setState(false);
            cF.c = new Array();
            cF.nC = 0;
            cF.isInitial = false;
            if((cF.state == NodeStatus.reset && cF.pNode.state == NodeStatus.reset) || cF.state == NodeStatus.del)
            {
                if(cF.isActive)
                    this.setArrowIcon(null);
                var thisNode = cF.nObj;
                if(cF.id != this.rootId)
                {
                    // del-Nodes aus nodeList löschen
                    //if(cF.state == NodeStatus.del)
                    {
                        this.nodeList[cF.id] = null;
                        util.recRemove(thisNode, true);
                    }
                }
            }
        }
    }
    this.doNodeClick = function (ident)
    {
        var key = ident.substr(2);
        if(ident.indexOf("tI") == 0)
        {
            this.clickNode(key);
            return null;
        }
        else if(ident.indexOf("nI") == 0)
            return key;
        else
            return ident.substr(1);
    }
    this.addChildren = function (nObjects)
    {
        var cLKey = null;
        for(var key in nObjects)
        {
            var subArr = nObjects[key];
            var cNode = this.getJSNode(key);
            if(cNode)// && cNode.isF == true)
            {
                //var addNewSibling = cNode.nC > 0;
                for(var i = 0; i < subArr.length; i++)
                {
                    var nF = subArr[i];
                    cNode.addChild(nF);
                    if(nF.aux.ACT)
                        cLKey = nF.id;
                }
                cNode.isF = cNode.nC > 0;
                this.clickNode(cNode.id);
            }
        }
        if(cLKey)
            this.setArrowIcon(cLKey);
    }
    this.updateNode = function (nDesc, nLnk, isF)
    {
        var cF = this.nodeList[nLnk];
        cF.isF = isF;
        if(nDesc && cF && cF.desc != nDesc)
        {
            cF.desc = nDesc;
            // firstChild - FlexBox
            // lastChild - Text
            cF.nObj.firstChild.lastChild.innerHTML = nDesc;
        }
        return cF;
    }
    this.getNodeCoords = function (key)
    {
        var rV = { top: 0, left: 0, width: 0 }, cObj = null;
        var cF = this.getJSNode(key);
        if(cF && cF.nObj)
            cObj = cF.nObj;
        if(cObj)
        {
            rV.left = cObj.offsetLeft;
            rV.top = cObj.offsetTop;
            cObj = cObj.rows[0].lastChild;
            rV.left += cObj.offsetLeft;
            rV.top += cObj.offsetTop;
            var cBody = document.body;
            rV.left -= cBody.scrollLeft;
            rV.top -= cBody.scrollTop;
            rV.width = cObj.offsetWidth;
        }
        return rV;
    }
    this.doGetChildren = function ()
    {
        return false;
    }
    // init root
    // (root muss existieren, damit mehrere Kinder der 1. Ebene den gleichen Vater haben!)   
    var rootObj = this.getJSNode(this.rootId);
    if(rootObj == null)
    {
        rootObj = document.createElement("DIV");
        this.container.appendChild(rootObj);
        rootObj.id = "N" + this.rootId;
        var root = new Node("", this.rootId, null);
        root.nObj = rootObj;
        this.nodeList[this.rootId] = root;
    }
    //this.initIcons();
    NativeNode.prototype.parentTree = this;
}
// Gibt Objekt zurück, wenn der Trenner gefunden wurde, sonst 0
// Kann die Ebene verlässlich abgeleitet werden?
function countChar(key)
{
    var count = /~/.exec(key);
    return count ? count : 0;
}

// Conditioning images in div einfügen
function addConditioning(pDiv, tm)
{
    for(var ahKey in tm)
    {
        var ah = tm[ahKey];
        if(ah)
        {
            var obj = document.createElement('DIV');
            obj.className = "ah" + ahKey + (ah == "False" ? "_inv" : "");
            pDiv.appendChild(obj);
        }
    }
}
