﻿function TreeSection(id, ref)
{
    Section.call(this, id, ref);
    if(ref && typeof util != "undefined")
        this.sP = util.getNode(ref, "section", { id: id });
    this.hasChanges = false;
}

TreeSection.prototype = new Section();

TreeSection.prototype.evalData = function evalData(sEvt, dOs)
{
    if(typeof this.sP == "undefined")
        return false;
    var c;
    //debugger;
    for(var i = 0; i < dOs.length; i++)
    {
        var dObj = dOs[i];
        // DOM node:
        var cObj = null;
        try
        {
            var cObj = document.getElementById(util.getId(this.id, dObj.id));

            // die eval-Funktionen können durch die Sections überschrieben werden
            switch(dObj.type)
            {
                case cc.cnst.dtp_tree:
                case cc.cnst.dtp_node:
                case cc.cnst.dtp_nodeType:
                    // das werten nur TableSections + Ableitungen aus
                    if(typeof this.evalRows == "function")
                        this.evalRows(dObj, cObj);
                    break;
            }
        } catch(ex) { this.trace("error", "evalData()", dObj.id + ": " + (ex.stack || ex.message)); }
    }
    this.finalize();
}
TreeSection.prototype.evalRows = function evalRows(dObj)
{
    if(typeof this.sP == "undefined")
        return null;

    var colCount = dObj.dV.length;
    var _this = this;

    // DOM node:
    var cObj = null, cCell = null, col = null;
    try
    {
        switch(dObj.type)
        {
            case cc.cnst.dtp_tree:
                var sP = this.sP;
                this.tree = new Tree(sP, this.id, dObj.aux[cc.cnst.aux_topSection]);
                this.fLObjects = new Array();

                util.toggleClass("tree", this.tree.container, true);
                util.registerCE(this.sP, "click", ({ fn: [

                    /* Node actions 
                    * Zustände des Knotens am node-Objekt und als cNode-Member
                    * tieferliegende css-Klassen geben nur die Struktur an */
                function (node, evt)
                {
                    var cellType = null, action = null;
                    var arr = node.id.split(util.keyDlm);
                    var key = arr[arr.length - 1];
                    var cNode = _this.tree.getJSNode(node.id.substr(1));
                    var culprit = evt.target;
                    var myP = {};
                    if(cNode)
                    {
                        // auch unteres Klapp-Control mitnehmen (wenn der Knoten offen ist!):
                        if(culprit.className.indexOf("node") > -1)
                        {
                            // Hier geht es nicht um den Klappzustand den Knotens (cNode.isOpen),
                            // sondern darum, ob die Daten sichtbar sind
                            if(cNode.hasVisibleData)
                                cellType = "wrpFlex";
                        }
                        else
                        {
                            var css = null;
                            while(!((css = culprit.className) && (css == "tI" || css == "mI" || css == "nI" || css == "desc" || css == "wrpFlex")))
                                culprit = culprit.parentNode;
                            cellType = culprit.className;
                        }
                    }
                    // Tree OP nur auf TreeIcon
                    switch(cellType)
                    {
                        case "tI":
                            // reagiert nur an "Folder"
                            if(cNode.isF)
                            {
                                // explizit Kinder abrufen 
                                if(cNode.state == NodeStatus.init)
                                    action = cc.cnst.action_getChildren;
                                else
                                {
                                    // nur aufklappen
                                    _this.tree.clickNode(cNode.id);
                                    // Kinder sind geladen, trotzdem Zustand kommunizieren
                                    action = cc.cnst.action_expand;
                                    myP[cc.cnst.urlParamNames_val] = cNode.isOpen ? 1 : 0;
                                }
                            }
                            break;
                        case "mI":
                            // Kontextmenü anfordern
                            if((action = _this.tree.nodeTypes[node.getAttribute("data-type")][cc.cnst.aux_action]))
                            {
                                var sKey = cc.cnst.id_contextPfx + _this.id;
                                var s = cc.sectionMap[sKey] = new DialogSection(sKey);
                                s.aux.evt = evt;
                            }
                            break;
                        case "wrpFlex": /* Klapp-Control */
                        case "desc":
                        case "nI":
                            if (cNode.isActive)
                            {
                                // zugeklappt & aktiv: aufklappen!
                                if (!cNode.isOpen)
                                {
                                    // nur aufklappen
                                    _this.tree.clickNode(cNode.id);
                                    // Kinder sind geladen, trotzdem Zustand kommunizieren
                                    action = cc.cnst.action_expand;
                                    myP[cc.cnst.urlParamNames_val] = 1;//cNode.isOpen ? 1 : 0;
                                }
                                cNode.toggleVisibleData();
                            }
                            else
                                // aufklappen und selektieren
                                action = cc.cnst.action_nodeSelect;
                            break;
                    }

                    if(action)
                    {
                        myP[cc.cnst.urlParamNames_key] = key;
                        myP[cc.cnst.urlParamNames_action] = action;
                        cc.fireEvent("selectItem", myP);
                    }
                } ]
                }));
                util.registerCE(this.sP, "context", cc.cntrls[this.sP.id]["click"]);

                break;
            case cc.cnst.dtp_nodeType:
                // Kategorie, die im Baum vorkommt sollte definiert sein:
                // Action für Kontextmenü?
                if(dObj.aux[cc.cnst.aux_action])
                    this.tree.nodeTypes[dObj.id] = dObj.aux;
                break;
            case cc.cnst.dtp_node:

                // Zeile füllen
                var rId = util.getId(this.id, dObj.id);

                var pN = { id: rId, css: "node" };

                // Für pseudo-Überschriften:
                util.joinClass(pN, dObj.aux[cc.cnst.aux_css]);

                var parentId = dObj.aux[cc.cnst.aux_parent] ? util.getId(this.id, dObj.aux[cc.cnst.aux_parent]) : this.tree.rootId;
                var cNode = this.tree.getJSNode(rId);

                // Knoten, die noch nicht da sind, werden nach parent_id strukturiert
                if(cNode == null)
                {
                    var nF = new Node(dObj.desc, rId, null);
                    nF.isF = dObj.aux[cc.cnst.aux_noChild] != "true";
                    var nType = dObj.aux[cc.cnst.aux_nodeType];
                    nF.aux[cc.cnst.aux_nodeType] = nType;
                    if(this.tree.nodeTypes[nType])
                        nF.aux.contextMenu = true;
                    nF.aux.ACT = dObj.selected;
                    nF.aux[cc.cnst.aux_childId] = dObj.id;
                    nF.aux[cc.cnst.aux_status] = dObj.aux[cc.cnst.aux_status];
                    //...
                    this.addChange(parentId, nF);
                }
                else if(dObj.aux[cc.cnst.aux_del])
                {
                    // Node löschen 
                    cNode.state = NodeStatus.del; // DELETE
                    var pNode = cNode.pNode;
                    pNode.state = NodeStatus.reset; // RESET me
                    this.tree.delNode(pNode);
                    addChange(pNode.id, cNode);
                }
                else if(dObj.aux[cc.cnst.aux_reset])
                {
                    // Node reset 
                    cNode.state = NodeStatus.reset;
                    this.tree.delNode(cNode);
                    cNode.state = NodeStatus.init;
                }
                else if(dObj.aux[cc.cnst.aux_commitNode])
                {
                    // commit: alle bis hierher ausgwerteten Änderungen in den Baum übertragen
                    this.finalize();
                }
                else if(dObj.aux[cc.cnst.aux_close])
                {
                    // Node schließen 
                    if(cNode.isOpen)
                        this.tree.clickNode(dObj.id);
                }
                else
                {
                    // durch Eingabefeld geänderter Titel 
                    var cF = this.tree.updateNode(dObj.desc, rId, !dObj.aux[cc.cnst.aux_noChild]);
                    if(dObj.selected)
                    {
                        try
                        {
                            if(cF.nObj.style.display == "none")
                                cF.nObj.style.display = "";
                        } catch(ex) { cc.traceError("evalRows()", ex.stack); }
                        this.tree.setArrowIcon(rId);
                    }
                }
                break;
        }
    } catch(ex) { this.trace("error", "evalData()", dObj.id + ": " + ex.stack); }
    return cObj;
}
TreeSection.prototype.addChange = function addChange(pId, n)
{
    this.hasChanges = true;
    var subArr = this.fLObjects[pId];
    if(!subArr)
    {
        subArr = [];
        this.fLObjects[pId] = subArr;
    }
    subArr[subArr.length] = n;
}
// Änderungen im Baum sind übernommen
// jetzt neue Kinder einspielen
TreeSection.prototype.finalize = function ()
{
    if(this.hasChanges)
    {
        this.tree.addChildren(this.fLObjects);
        this.fLObjects = new Array();
        this.hasChanges = false;
    }
};
// Alle DOs aller Sections sind durch -> Höhe anpassen
TreeSection.prototype.adjustDimensions = function ()
{
// Resize nach Änderung der Fenstergröße und
// nach Aktionen im Baum, wenn alle DOs durch sind
    if(this.tree.cL)
        this.sP.style.minHeight = this.tree.cL.nObj.lastChild.offsetHeight + "px";
    else
        this.sP.style.minHeight = "auto";

}
