// Event queue instance 
var eventQueue = null;
// Definition of class EventQueueElement 
function EventQueueElement(aName, aType, aParameterString)
{
	this.actionName = aName;
	this.actionType = aType;
	this.actionParameter = aParameterString;
}
// Definition of class EventQueue 
function EventQueue(_codeFrame, _baseURL)
{
	this.run = true;
	this.runningEvent = null;
	this.queueItems = [];
	this.codeFrame = _codeFrame;
	this.baseURL = _baseURL;
	this.lastUrl = null;
}
// add client event information to event queue
EventQueue.prototype.addQueueEvent = function addQueueEvent(actions, parameters)
{
    // 20111201; bhm; WA: zuweilen kommen events doppelt -> hier testen und ignorieren
    // 20140917; bhm; Falls der Effekt noch auftritt, WA wieder reinnehmen (Achtung: navigateBack anders lsen!)
    //    var pString = util.joinSearchString(parameters);
    //    if(this.lastPList == pString)
    //        return false;
    //    this.lastPList=pString;

    var i = 0;
    while(i < actions.length)
    {
        // Neue Instanz ist wichtig fr evtList!
        this.queueItems[this.queueItems.length] = { name: (actions[i].name || ""), type: actions[i].type, param: parameters };
        i++;
    }

    if(!this.run)
    // registrieren und events weiter laufen lassen
        setTimeout(function () { cc.eventQueue.launchEvent() }, 5);
}
// launch next client event
EventQueue.prototype.launchEvent = function launchEvent()
{
    while(!this.run && this.queueItems.length > 0)
    {
        // store the current event 
        this.runningEvent = this.queueItems[0];
        // shift left 
        this.queueItems = this.queueItems.slice(1, this.queueItems.length);
        // launch action with parameters 
        var parameters = this.runningEvent.param;
        var pString = "";
        switch(this.runningEvent.type)
        {
            case "javascript":
                if(parameters)
                {
                    pString = "{";
                    for(key in parameters)
                    {
                        var s = parameters[key];
                        if(isNaN(s))
                        {
                            s = cc.decodeJsString(s); /*
					    // geschtzter Backslash (fr Pfade!) hier behandeln, wegen nachfolgender Verkettung */
                            s = s.replace(/\\/g, "\\\\");
                        }
                        if(pString.length > 1)
                            pString += ",";
                        pString += key + ":\"" + s + "\"";
                    }
                    pString += "}";
                }
                cc.traceInfo("launchEvent()", "--- " + "cc." + this.runningEvent.name + "(" + pString + ")" + " ---");
                eval("cc." + this.runningEvent.name + "(" + pString + ")");
                this.finishedEvent();
                break;
            case "http":
                this.run = true;
                if(typeof parameters.target == "string")
                {
                    this.lastUrl = "modules/kernel/UI/controller/dynCF.aspx";
                    parameters.target = this.codeFrame.frameElement.id;
                    parameters.action = this.baseURL + "modules/kernel/UI/controller/dynCF.aspx";
                    //parameters.method = "get";
                    cc.traceInfo("launchEvent()", "--- form submit ---");
                    parameters.submit();
                }
                else if(typeof parameters.url == "string")
                {
                    cc.traceInfo("launchEvent()", "--- " + parameters.url + " --- -> " + this.queueItems.length);
                    //setTimeout('releaseRequest("' + parameters.url + '")', 50);
                    this.releaseRequest(parameters.url);
                }
                else
                {
                    if(parameters)
                    {
                        for(key in parameters)
                        {
                            // geschtzter Backslash (fr Pfade!) -> wie im javascript-Zweig behandeln!
                            // (encoding von "&#92;" wird nicht mehr aufgelst) 
                            var s = parameters[key];
                            if(isNaN(s))
                                s = cc.decodeJsString(s);
                            pString += (pString.length > 0 ? "&" : "") + key + "=" + encodeURIComponent(s);
                        }
                    }
                    var _this = this;
                    var s = cc.completeURL(pString);
                    cc.traceInfo("launchEvent()", "--- " + s + " --- -> " + this.queueItems.length);

                    //setTimeout(function () { releaseRequest(_this, 'modules/kernel/UI/controller/dynCF.aspx?' + s); }, 50);
                    this.releaseRequest('modules/kernel/UI/controller/dynCF.aspx?' + s);
                }
                break;
        }
    }
}
// reset running state of event queue 
EventQueue.prototype.finishedEvent = function finishedEvent()
{
	this.run = false;
	this.runningEvent = null;
	this.launchEvent();
	//cc.traceInfo("finishedEvent()", this.run + ", " + this.queueItems.length);
	if(!this.run && typeof(cc.hideGlasspane) == "function")
    {
		cc.hideGlasspane();/* 
        // Die letzte Action ist vollstndig durchgelaufen, da kann der Teststring dann weg! */
		this.lastPList = "";

		// alles ist fertig: check next focus
        this.setNextFocus();
    }
}
EventQueue.prototype.releaseRequest = function releaseRequest(url)
{
    this.lastUrl = url;
    this.codeFrame.location.replace(this.baseURL + url);
}
EventQueue.prototype.setNextFocus = function ()
{
    try
    {
        var cObj = null;
        var dialog = cc.getLastDialog();
        var actObj = document.activeElement;

        if (util.isEditableControl(actObj))
            cObj = actObj;
            // ein requiresFocus-Element muss im richtigen Kontext liegen
        else if (cc.requiresFocus && (!dialog || dialog.contains(cc.requiresFocus)))
            cObj = cc.requiresFocus;
        else if (dialog)
        {
            // Falls der akt. Dialog keine Eingabefelder hat, wird der Dialog fokussiert
            cObj = dialog;
        }
        else
            cObj = document.body;
        if (cObj && cObj != actObj)
        {
            //cc.traceInfo("setNextFocus()", cObj.id + " - " + cObj.tagName + "(" + (actObj ? actObj.id || actObj.tagName : "none") + ")");
            cObj.focus();
        }
        cc.traceInfo("setNextFocus()", cObj.id + " - " + cObj.tagName);
        cc.requiresFocus = null;
    }
    catch (ex) { }
}
