	var traceData = new Array();
	var traceWindow;
	var traceMode;
	var initialized = false;
	var traceDocumentPath = "about:blank";
	var traceLevel = 0;
	function setTraceMode(mode, lvl, t)
	{
	    traceMode = mode;
	    traceLevel = parseInt(lvl) || 0;
		if (traceMode=="silent")
			traceData = new Array();
		else
		{
		    try
		    {
		        traceWindow = window.open(traceDocumentPath, "traceWindow", "top=0,left=30,width=" + (screen.width - 40) + ",height=250,resizable=1,scrollbars=1");
		        setTimeout(function () { traceWindow.document.title = t; }, 1000);
		    }
		    catch(ex) { /* Fenster existiert schon? */}
		}
		initialized = true;
	}

	function doTrace(type, col1, col2, col3)
	{
	    // traceLevel=2: alles geht durch
	    if(!traceWindow || traceWindow.closed || !(traceLevel == 1 && type == "error") && traceLevel <= 1)
	    {
	        // falls das Fenster geschlossen wurde, zurcksetzen
            if(!traceWindow || traceWindow.closed)
	            traceLevel = 0;
	        return false;
	    }
	    if(!initialized)
			setTraceMode("silent");
		
		if (traceMode=="silent")
			traceSilent(type, col1, col2, col3);
		else
			traceVisible(type, col1, col2, col3);
	}

	function traceSilent(_type, _col1, _col2, _col3)
	{
		if (traceData.length>99)
		{
			traceData.shift();
		}
		traceData[traceData.length] = {type:_type, col1:_col1, col2:_col2, col3:_col3, date:new Date()};
	}
	
	function traceVisible(_type, _col1, _col2, _col3, _date)
	{
		try
		{
			if (traceWindow.closed)
			{
				setTraceMode(traceMode);
			}
			var dateObj;
			if (typeof(_date)=="object" && typeof(_date.getTime)=="function")
			{
				dateObj = _date;
			}
			else
				dateObj = new Date();
				
			var date = fillBefore(dateObj.getHours(), 2, "0") + ":" + fillBefore(dateObj.getMinutes(), 2, "0") + ":" + fillBefore(dateObj.getSeconds(), 2, "0") + "." + fillBefore(dateObj.getMilliseconds(), 3, "0");
			var dateId = "_"+date.replace(/[\.|:]/g, "_")+"_";
			var color = "#000000";
			if (_type=="error")
				color = "#DD0000";
			else
			if (_type=="success")
				color = "#009900";
			var font = "<div id='"+dateId+"' style='font-size:12px; font-family:monospace; padding:0px; margin:0px;border-bottom:1px dotted #EEEEEE;'><font color='" + color+ "'>";
			_col1 = _col1 + ": ";
			_col2 = _col2 + ": ";
	
			var	_col3Str = "";
			if (typeof(_col3)=="string")
				_col3Str = _col3;
			else
			{
				_col3Str = dump(_col3);
			}
				
			var newStr = font + date + "&nbsp;|&nbsp;" + fillAfter(_col1, 25, "&nbsp;") + fillAfter(_col2, 25, "&nbsp;") + _col3Str + "</font></div>";
	
			//traceWindow.document.body.insertAdjacentHTML("beforeEnd", newStr);
			traceWindow.document.body.innerHTML = traceWindow.document.body.innerHTML + newStr;
			var newEl = traceWindow.document.getElementById(dateId);
			if (typeof(newEl)!="undefined" && newEl!=null && typeof(newEl.scrollIntoView)!="undefined")
				newEl.scrollIntoView();
		}
		catch(e){}
	}
	
	function showTraced()
	{
		traceWindow = window.open(traceDocumentPath, "traceWindow", "top=0,left=0,width="+screen.width+",height=250,resizable=1,scrollbars=1");
		if (typeof(traceWindow)=="object" && typeof(traceWindow.document)=="object" && typeof(traceWindow.document.body)=="object")
		{
			traceWindow.document.title = "ORISA JavaScript Tracing";
			for (var i=0; i<traceData.length; i++)
				traceVisible(traceData[i].type, traceData[i].col1, traceData[i].col2, traceData[i].col3, traceData[i].date);
		}
		else
		if (confirm("Das Trace-Fenster konnte nicht geffnet werden. Mchten Sie es erneut versuchen?"))
		{
			setTimeout("showTraced()", 500);
		}
	}

	function fillBefore(s, desiredLength, fillChar)
	{
		s = s+"";
		var cnt = s.length;
		while (cnt<desiredLength)
		{
			s = fillChar + s;
			cnt++;
		}
		return s;
	}

	function fillAfter(s, desiredLength, fillChar)
	{
		s = s+"";
		var cnt = s.length;
		while (cnt<desiredLength)
		{
			s = s + fillChar;
			cnt++;
		}
		return s;
	}
	
	/*
	open a prompt to try and eval multiple statements after each other.
	useful for inspecting/debugging in browsers which don't have an integrated debugger (like Safari).
	*/
	function interactiveInspect(_p)
	{
		if (typeof(_p)!="string" || _p=="")
			_p="false";
		while(typeof(_p)=="string" && _p!="")
		{
			var _res="";
			try	
			{ 
				_res = _p+": "+eval(_p);
			}
			catch (_ex) 
			{
				_res = _p+": "+_ex.name+": "+_ex.message;
			}
			_p=prompt(_res, _p)
		}
	}
	
	
	function dump(obj)
	{
		var objStr = obj+"";
		
		/* tsc
		avoid dumping of HTMLElements because of too many iterations:
		- DOM2-compliant browsers (Opera, Mozilla) return [object HTMLxxxElement] as object+"", where xxx might be "" or "Body" or "Div"
		- IE returns [object] - the same as for any array etc., so we need to look for something that distinguishes container elements;
										I chose childNodes for that purpose
		*/

		if (typeof(obj)=="undefined" || obj==null || typeof(obj)=="string" || typeof(obj)=="number" || typeof(obj)=="boolean" || objStr.match("^\\[object HTML.*Element\\]$")==objStr || typeof(obj.childNodes)!="undefined")
			return objStr;
		var lastProp = null;
		try 
		{
			var resultStr = "[";
			for (var prop in obj)
			{
				lastProp = prop+"";
				if (obj[prop]==obj)
					resultStr += prop+": (self reference)";
				else
					resultStr += prop + ": " + dump(obj[prop]) + ", ";
			}
			resultStr += "]";
			resultStr = resultStr.replace(/, ]/, "]");
			return resultStr;
		} catch (ex)
		{
			return "(Exception occured while dumping "+obj+"."+lastProp+") "+ex.name+": "+ex.message;
		}
	}