﻿// Section-Definition
// neue Section normalerweise, wenn ein neuer Key in der TargetList (tL) des jsO gefunden wird (C# - Visibility!)
// Sollen Methoden an Sections überschrieben werden, müssen diese explizit an einem Section-Objekt definiert werden!
function AbstractSection()
{ }
AbstractSection.prototype.reset = function reset()
{
    //AbstractSection hat keine eigenen Member-Variablen
};
// allgemeine Methode zur Auswertung der jsO:
AbstractSection.prototype.evalImg = function (sP, dObj, cObj)
{
    var pN = { id: util.getId(this.id, dObj.id) };
    // Sprite-Bild?
    var s = dObj.aux[cc.cnst.aux_top];
    if (typeof s != "undefined")
    {
        sP = this.embedControl(sP, cObj, pN, dObj.aux[cc.cnst.aux_group], dObj.aux["title"], dObj.visible);
        pN.css = "img";
        cObj = util.getNode(sP, "div", pN);
        // Left ist 0 und top muss negativ sein!!!
        cObj.style.backgroundPosition = "0px -" + s + "px";
        cObj.style.backgroundImage = "url('" + dObj.aux[cc.cnst.aux_img] + "')";
        s = dObj.aux[cc.cnst.aux_width];
        if (s)
            cObj.style.width = s + "px";
        s = dObj.aux[cc.cnst.aux_height];
        if (s) cObj.style.height = s + "px";
        var f = util.createFN(dObj.aux[cc.cnst.aux_action] || (dObj.editable ? ["Change", dObj.id] : null));
        if (f)
        {
            util.registerCE(cObj, "click", { fn: f });
            util.addClass("tap", cObj);
        }
    }
    else if (typeof (s = dObj.aux[cc.cnst.aux_img]) != "undefined")
    {
        pN.src = s;
        cObj = util.getNode(sP, "IMG", pN);
    }
    else if (dObj.imgLst)
    {
        // Bilder: id + (src oder null)
        var dim = { w: 0, h: 0 };
        for (var i = 0; i < dObj.imgLst.length; i++)
        {
            var imgData = dObj.imgLst[i];
            pN.src = imgData.src;
            if (dObj.desc && !cc.isTouchable)
                pN.title = dObj.desc
            if (imgData.idx) pN.id = util.getId(pN.id, imgData.idx);
            cObj = util.getNode(sP, "IMG", pN);
            if (imgData.x)
                cObj.style.left = imgData.x + "px";

            if (imgData.y)
                cObj.style.top = imgData.y + "px";

            if (imgData.z) cObj.style.zIndex = imgData.z;
            if (imgData.width > 0)
            {
                cObj.style.width = imgData.width + "px"; /*
                var w = parseInt(imgData.x) + parseInt(imgData.width);
                if(dim.w < (w))
                    dim.w = w;*/
            }
            if (imgData.height > 0)
            {
                cObj.style.height = imgData.height + "px";
                var h = parseInt(imgData.y) + parseInt(imgData.height);
                if (dim.h < (h))
                    dim.h = h;
            }
            var f = util.createFN(dObj.aux[cc.cnst.aux_action] || (dObj.editable ? ["Change", dObj.id] : null));
            if (f)
            {
                util.registerCE(cObj, "click", { fn: f });
                util.addClass("tap", cObj);
            }
        } /* Breite kommt durch die Bilder 
        if(dim.w > 0 && sP.offsetWidth < dim.w)
            sP.style.width = dim.w + "px";*/
        // der erforderlichen Höhe 20px für evtl. Scrollbar zuschlagen:
        if (dim.h > 0 && sP.offsetHeight < (dim.h += 20))
            sP.style.height = dim.h + "px";
    }
    util.toggleClass("sel", cObj, dObj.selected);
    return cObj;
};
AbstractSection.prototype.evalCheckbox = function (sP, dObj, cObj)
{
    if (!cObj)
    {
        var dId = util.getId(this.id, dObj.id);
        // Post geht nicht ohne "name"-Attribute!
        var pN = { id: dId, type: "checkbox", name: dObj.id };

        // das Panel ersetzt das embedControl-Fieldset
        var pnl = util.getNode(sP, "div", { css: dObj.type.toLowerCase() });

        if (dObj.dV.length > 0)
        {
            // Title?
            if (dObj.desc)
                util.addNode(pnl, "div", { css: "hdr" }).innerHTML = dObj.desc;

            for (var j = 0; j < dObj.dV.length; j++)
            {
                var dV = dObj.dV[j];
                var dVId = util.getId(this.id, dObj.id, dV.id);
                pN.id = dVId;
                if (dV.selected)
                    pN.checked = "checked";
                var wrp = util.addNode(pnl, "div", { css: "wrp" });
                (cObj = util.addNode(wrp, "input", pN)).value = dV.id;
                (util.addNode(wrp, "label", { 'for': dVId })).innerHTML = dV.value;

                // innerhalb von forms keine eigene action
                if (!this.aux.form)
                    util.registerCE(cObj.id, "click", { ce: (dV.aux[cc.cnst.aux_action] || ["Change", dObj.id, dV.id]) });
            }
        }
        else
        {
            if (dObj.selected)
                pN.checked = "checked";
            var wrp = util.addNode(pnl, "div", { css: "wrp" });
            cObj = util.getNode(wrp, "input", pN);
            (util.addNode(wrp, "label", { 'for': dId })).innerHTML = dObj.desc;

            // WA: "Password lost" als submit() + zurücksetzen der Checkbox:
            if (this.isDlg && this.aux.form && this.aux.pgName == cc.cnst.PG_DLGLOGIN)
            {
                var _form = this.aux.form;
                util.registerCE(cObj.id, "click", {
                    fn: function ()
                    {
                        // Achtung: der Server muss die geklickte Checkbox wieder false setzen
                        // (wegen der Timeouts können wir das hier nicht mehr machen)
                        cc.fireEvent("selectItem", _form);
                    }
                });
            }
            else
                util.registerCE(cObj.id, "click", { ce: (dObj.aux[cc.cnst.aux_action] || ["Change", dObj.id, "value"]) });
        }
    }
    else if (dObj.selected3 != util.cmpVal.DC)
        cObj.checked = dObj.selected;
    this.checkChangeability((pnl || cObj.parentNode.parentNode), cObj, dObj.editable);
    return cObj;
};
AbstractSection.prototype.evalRadioButton = function (sP, dObj, cObj)
{

    
    var pN = { type: "radio", name: dObj.id };
    var pnl = null;
        if (dObj.dV.length > 0)
        {
            for (var j = 0; j < dObj.dV.length; j++)
            {
                var dV = dObj.dV[j];
                var dVId = util.getId(this.id, dObj.id, dV.id);
                if ((cObj = document.getElementById(dVId)) == null)
                {
                    if (pnl == null)
                    {
                        pnl = util.getNode(sP, "div", { css: dObj.type.toLowerCase() });

                        // Title?
                        if (dObj.desc)
                            util.addNode(pnl, "div", { css: "hdr" }).innerHTML = dObj.desc
                    }

                    pN.id = dVId;
                    //pnl = util.getNode(sP, "div", { css: dObj.type.toLowerCase() });
                    var wrp = util.addNode(pnl, "div", { css: "wrp" });
                    (cObj = util.addNode(wrp, "input", pN)).value = dV.id;
                    (util.addNode(wrp, "label", { 'for': dVId })).innerHTML = dV.value;

                    // innerhalb von forms keine eigene action
                    if (!this.aux.form)
                        util.registerCE(cObj.id, "click", { ce: (dV.aux[cc.cnst.aux_action] || ["Change", dObj.id, dV.id]) });
                }
                cObj.checked = dV.selected;
                this.checkChangeability((pnl || cObj.parentNode.parentNode), cObj, typeof dV.aux[cc.cnst.aux_disabled] == "undefined");
            }
        }
        else
        {
            if (!cObj)
            {
                var dId = util.getId(this.id, dObj.id);
                pN.id = dId;
                pnl = util.getNode(sP, "div", { css: dObj.type.toLowerCase() });
                var wrp = util.addNode(pnl, "div", { css: "wrp" });
                cObj = util.getNode(wrp, "input", pN);
                (util.addNode(wrp, "label", { 'for': dId })).innerHTML = dObj.desc;
                util.registerCE(cObj.id, "click", { ce: (dObj.aux[cc.cnst.aux_action] || ["Change", dObj.id, "value"]) });
            }
            if (dObj.selected3 != util.cmpVal.DC)
                cObj.checked = dObj.selected;
            this.checkChangeability((pnl || cObj.parentNode.parentNode), cObj, dObj.editable);
        }
    
    return cObj;
};
AbstractSection.prototype.evalSelect = function (sP, dObj, cObj)
{
    var isPostItem = sP.method || sP.parentNode.method;
    var cId = util.getId(this.id, dObj.id);
    var pN = {};
    if(cObj == null)
    {
        pN = { id: cId, name: dObj.id };
        util.joinClass(pN, dObj.aux[cc.cnst.aux_css]);
    }
    sP = this.embedControl(sP, cObj, pN, dObj.aux[cc.cnst.aux_group], dObj.aux["title"], dObj.visible);
    if(!cObj)
    {
        sP = this.evalTT(sP, dObj);
        cObj = util.addNode(sP, "select", pN);
    }
    else
    {
        // remove old entries
        cObj.options.length = 0;
    }
    var domValues = dObj.dV;
    if(domValues.length > 0)
    {
        // add new entries
        for(var j = 0; j < domValues.length; j++)
        {
            var domVal = domValues[j];
            util.addNode(cObj, "OPTION", { value: domVal.id, text: domVal.value, selected: domVal.selected });
        }
    }
    // Label & control disablen?
    this.checkChangeability(cObj.parentNode, cObj, dObj.editable && domValues.length > 0);

    // postItems bekommen keine Action
    if(!isPostItem)
        util.registerCE(cObj.id, "change", (cObj.disabled ? null : { ce: (dObj.aux[cc.cnst.aux_action] || ["Change", dObj.id, "value"]) }));
    return cObj;
};
AbstractSection.prototype.evalMatchBox = function (sP, dObj, cObj)
{
    var mbc = this.aux.mbc && this.aux.mbc[cObj.id] || null;
    if(!mbc)
    {
        if(!this.aux.mbc)
            this.aux.mbc = [];
        mbc = new MatchBoxControl(this, sP, dObj);
        this.aux.mbc[mbc.id] = mbc;
    }
    else
    {
        mbc.reset(dObj);
    }
}
AbstractSection.prototype.evalSwiper = function (sP, dObj, cObj)
{
    var swiper = this.aux.swp && this.aux.swp[cObj.id] || null;
    if(!swiper)
    {
        if(!this.aux.swp)
            this.aux.swp = [];
        swiper = new SwiperControl(this, sP, dObj);
        this.aux.swp[swiper.id] = swiper;
    }
    else
    {
        //swiper.reset(dObj);
    }
}
AbstractSection.prototype.evalTextBox = function evalTextBox(sP, dObj, cObj)
{
    var isPostItem = sP.method || sP.parentNode.method;
    // id + type=text + value
    var cId = util.getId(this.id, dObj.id); //this.id || sP.parentNode.id???
    // neu: alles
    // upd: value (readonly/disabled?)
    var pN = cObj ? {} : { id: cId, name: dObj.id };

    // Pflichtfeld-Zustand toggeln
    util.joinClass(pN, (dObj.aux[cc.cnst.aux_mandt] ? cc.cnst.aux_mandt : ""));
    util.joinClass(pN, dObj.aux[cc.cnst.aux_css]);

    sP = this.embedControl(sP, cObj, pN, dObj.aux[cc.cnst.aux_group], dObj.aux["title"], dObj.visible);

    if(!cObj)
    {
        sP = this.evalTT(sP, dObj);
        cObj = util.addNode(sP, "textarea", pN);
    }
   this.checkChangeability(cObj.parentNode, cObj, dObj.editable);
  
    // Mit innerHTML funktioniert das change-Event initial nicht!
    cObj.value = dObj.desc;

    // wenn die Werte verschieden sind -> isModified
    cObj.defaultValue = cObj.value;

    // bekommt das Feld den Focus?
    checkFocus(cObj);

    // postItems bekommen keine Action
    if(!isPostItem)
    {
        var f = util.createFN(dObj.aux[cc.cnst.aux_action] || ["Change", dObj.id, "value"]);
        util.registerCE(cObj, "enter", (cObj.disabled ? null : { fn: f }));
        util.registerCE(cObj, "change", (cObj.disabled ? null : { fn: f }));
    }
    // kein Rückgabewert!
}
AbstractSection.prototype.evalInput = function evalInput(sP, dObj, cObj)
{
    var isPostItem = sP.method || sP.parentNode.method;
    // id + type=text + value
    var cId = util.getId(this.id, dObj.id); //this.id || sP.parentNode.id???
    // neu: alles
    // upd: value (readonly/disabled?)
    var pN = cObj ? {} : { id: cId, name: dObj.id };

    // default ist "text", cc.cnst.dtp_password kann eigentlich durch cc.cnst.aux_inpType ersetzt werden!
    pN.type = dObj.type == cc.cnst.dtp_password ? "password" : dObj.aux[cc.cnst.aux_inpType] ? dObj.aux[cc.cnst.aux_inpType] : "text";

    pN.value = dObj.desc ? util.getUnicodeMessage(dObj.desc) : "";

    // Pflichtfeld-Zustand toggeln
    util.joinClass(pN, (dObj.aux[cc.cnst.aux_mandt] ? cc.cnst.aux_mandt : ""));
    util.joinClass(pN, dObj.aux[cc.cnst.aux_css]);

    sP = this.embedControl(sP, cObj, pN, dObj.aux[cc.cnst.aux_group], dObj.aux["title"], dObj.visible);

    if(!cObj)
    {
        // "defautText" an input-Controls als Placeholder verwenden
        if(dObj.aux[cc.cnst.aux_defaultTxt])
            pN.placeholder = dObj.aux[cc.cnst.aux_defaultTxt];

        sP = this.evalTT(sP, dObj);
        cObj = util.addNode(sP, "input", pN);
    }
    else
    {
        // "defautText" an input controls als placeholder verwenden
        if(dObj.aux[cc.cnst.aux_defaultTxt])
            cObj.placeholder = dObj.aux[cc.cnst.aux_defaultTxt];
    }
    // wenn die Werte verschieden sind -> isModified
    cObj.defaultValue = cObj.value;
   this.checkChangeability(cObj.parentNode, cObj, dObj.editable);

    // bekommt das Feld den Focus?
    checkFocus(cObj);

    // postItems bekommen keine Action
    // Wenn schon Actions vorhanden, auch nicht!
    if(!isPostItem)
    {
        var f = util.createFN(dObj.aux[cc.cnst.aux_action] || ["Change", dObj.id, "value"]);
        if(!(cc.cntrls[cObj.id] && cc.cntrls[cObj.id].enter))
            util.registerCE(cObj, "enter", (cObj.disabled ? null : { fn: f }));
        if(dObj.type != cc.cnst.dtp_selAutoComplete && !(cc.cntrls[cObj.id] && cc.cntrls[cObj.id].change))
            util.registerCE(cObj, "change", (cObj.disabled ? null : { fn: f }));
    }
    // kein Rückgabewert!
}
AbstractSection.prototype.evalFile = function evalFile(sP, dObj, cObj)
{
    var isPostItem = sP.method || sP.parentNode.method;
    // id + type=text + value
    var cId = util.getId(this.id, dObj.id); //this.id || sP.parentNode.id???
    // neu: alles
    // upd: value (readonly/disabled?)
    var pN = cObj ? { value: (dObj.desc || "")} : { id: cId, name: dObj.id, maxLength:100000, size:30, type:"file" };

    // Pflichtfeld-Zustand toggeln
    util.joinClass(pN, (dObj.aux[cc.cnst.aux_mandt] ? cc.cnst.aux_mandt : ""));

    sP = this.embedControl(sP, cObj, pN, dObj.aux[cc.cnst.aux_group], dObj.aux["title"], dObj.visible);

    if(!cObj)
    {
        cObj = util.addNode(sP, "input", pN);

        // Felder nicht disablen, werden sonst nicht gepostet
        if(!dObj.editable)
            cObj.setAttribute("readonly", "readonly");
    }
    else
    {
        if(dObj.editable)
            cObj.removeAttribute("readonly", "readonly");
        else
            cObj.setAttribute("readonly", "readonly");
    }

    // postItems bekommen keine Action
    if(!isPostItem)
    {
        var f = util.createFN(dObj.aux[cc.cnst.aux_action] || ["Change", dObj.id, "value"]);
        util.registerCE(cObj, "enter", (cObj.disabled ? null : { fn: f }));
        util.registerCE(cObj, "change", (cObj.disabled ? null : { fn: f }));
    }
    // kein Rückgabewert!
}
AbstractSection.prototype.evalTextList = function evalTextList(sP, dObj, cObj)
{
    if(cObj == null)
    {
        cObj = util.addNode(sP, "div", { id: util.getId(this.id, dObj.id), css: dObj.type.toLowerCase() });
    }
    else
    // Kinder entfernen
        util.recRemove(cObj);

    // Title?
    if(dObj.desc)
        util.addNode(cObj, "span", { css: "hdr" }).innerHTML = dObj.desc

    for(var j = 0; j < dObj.dV.length; j++)
    {
        var dV = dObj.dV[j],
            pN = dV.selected ? { css: "sel"} : {};
        if(dV.aux[cc.cnst.aux_tt])
            pN.title = dV.aux[cc.cnst.aux_tt];
        sP = this.embedControl(cObj, null, null, null, dV.aux["title"], true);

        util.addNode(sP, "span", pN).innerHTML = dV.value;
    }
    return cObj;
}
AbstractSection.prototype.embedControl = function embedControl(sP, cObj, pN, grp, title, visible)
{
    var invisible = !visible;

    if(!cObj)
    {
        // Gruppierung
        if(grp)
        {
            // Gruppe registrieren
            if(this.aux.groups[grp].length == 1)
                sP = this.aux.groups[grp][0];
            else
            {
                // Panel außen
                var grpPnl = util.addNode(sP, null, { css: "groupPnl" });
                if(invisible)
                    util.addClass("visNone", grpPnl);

                if(title)
                {
                    util.addNode(grpPnl, "label", { 'for': pN.id }).innerHTML = title;

                    // PLZ/Ort in Projekt- bzw. Kundendaten braucht beide Klassen (geht das schöner?) -> siehe HIT!
                }
                //sP = this.aux.groups[grp][0] = util.addNode(util.addNode(grpPnl, "fieldset"),"div",{css:"wrp"});
                // statt fieldset div! (fieldset bug!)
                sP = this.aux.groups[grp][0] = util.addNode(grpPnl, "div", { css: "fieldset" });
            }
        }
        // mit Label
        else if(title)
        {
            sP = util.getNode(sP, "div", { css: " formItem" });
            if(invisible)
                util.addClass("visNone", sP);
            var pNLbl = pN && pN.id ? { 'for': pN.id} : {};
            (util.addNode(sP, "label", pNLbl)).innerHTML = title;
        }
        // Hidden-Feld
        else if(invisible)
            pN.type = "hidden";
    }
    else
    {
        var pObj = cObj.parentNode.parentNode;
        // Gruppierung?
        if(!util.hasClass("groupPnl", pObj))
        {
            pObj = cObj.parentNode;

            // mit Label
            if(pObj.tagName != "FIELDSET")
                pObj = null;
        }
        if(pObj)
        {
            if((invisible && !util.hasClass("visNone", pObj)) || (!invisible && util.hasClass("visNone", pObj)))
                util.toggleClass("visNone", pObj);
        }
        // Hidden-Felder bleiben unangetastet! 
        util.applyAttrList(cObj, pN);
    }
    return sP;
};

AbstractSection.prototype.evalLink = function (sP, dObj, cObj)
{
    var pN = { id: util.getId(this.id, dObj.id), css: dObj.type.toLowerCase() };
    util.joinClass(pN, dObj.aux[cc.cnst.aux_css]);

    // Gruppe?
    if(dObj.aux[cc.cnst.aux_group])
    {
        sP = this.embedControl(sP, cObj, pN, dObj.aux[cc.cnst.aux_group], dObj.aux["title"], dObj.visible);
    }
    if (dObj.aux[cc.cnst.aux_tt])
        pN.title = dObj.aux[cc.cnst.aux_tt];

    //  Hat das DO eine Action?   
    if(dObj.aux[cc.cnst.aux_target])
    {
        pN.href = dObj.aux[cc.cnst.aux_action];
        pN.target = dObj.aux[cc.cnst.aux_target];
    }
    else
        util.registerCE(pN.id, "click", { ce: dObj.aux[cc.cnst.aux_action] });
    if(!cObj)
    {
        if(dObj.aux[cc.cnst.aux_title])
        {
            // Katalog: Überschrift davor
            util.addNode(sP, "span", {css:"text hdl"}).innerHTML = dObj.aux[cc.cnst.aux_title]
        }
        cObj = util.addNode(sP, dObj.aux[cc.cnst.aux_action] ? "a" : "div", pN);
        cObj.innerHTML = dObj.desc;
    }
    else if(dObj.desc != null)
    {
        cObj.innerHTML = dObj.desc;
    }
    return cObj;
};
AbstractSection.prototype.evalLinkList = function (sP, dObj, cObj)
{
    var isBlockNav = (dObj.type == cc.cnst.dtp_blockNav), pN = null;
    if(cObj == null)
    {
        pN = { id: util.getId(this.id, dObj.id), css: dObj.type.toLowerCase() };
        util.joinClass(pN, dObj.aux[cc.cnst.aux_css]);

        // Gruppe?
        if (dObj.aux[cc.cnst.aux_group])
        {
            sP = this.embedControl(sP, cObj, pN, dObj.aux[cc.cnst.aux_group], dObj.aux["title"], dObj.visible);
        }
        cObj = util.addNode(sP, "ul", pN);
    }
    else
    // Kinder & Actions entfernen
        util.recRemove(cObj);

    // Title?
    if(dObj.desc && dObj.type != cc.cnst.dtp_panel)
        util.addNode(util.addNode(cObj, "li"), "span", { css: "hdr" }).innerHTML = dObj.desc

    for(var j = 0; j < dObj.dV.length; j++)
    {
        var dV = dObj.dV[j],
            dVId = util.getId(this.id, dObj.id, dV.id),
            action = null;

        // oben wurden alle Kinder enfernt -> Neuaufbau
        pN = dV.selected ? { css: "sel"} : {};
        pN.id = dVId;


        // BlockNavigator: ActionList mit autom. Actions, aber die oben-/ unten-Erweiterung rausnehmen 
        if(isBlockNav)
        {
            if(typeof dV.aux[cc.cnst.aux_disabled] == "undefined")
                action = ["Change", dObj.id.substr(0, dObj.id.length - 2), dV.id];
            if(!dV.value || dV.value == "&nbsp;")
            {
                pN.css = dV.id.toLowerCase();
                // WA vertical-align:baseline -> Buttons ohne Text verrutschen
                dV.value = "&nbsp;";
            }
        }
        else
            action = dV.aux[cc.cnst.aux_action];

        if (dV.aux[cc.cnst.aux_tt])
            pN.title = dV.aux[cc.cnst.aux_tt];

        util.joinClass(pN, dV.aux[cc.cnst.aux_css]);

        if(action != null || dV.aux[cc.cnst.aux_msg])
        {
            // External link
            if(dV.aux[cc.cnst.aux_target])
            {
                pN.href = action;
                pN.target = dV.aux[cc.cnst.aux_target];
            }
            // Mail link
            else if(dV.aux[cc.cnst.aux_msg])
            {
                pN.href = "mailto:?subject=" + dV.aux[cc.cnst.aux_title] + "&body=" + dV.aux[cc.cnst.aux_msg];
            }
            child = util.addNode(util.addNode(cObj, "li"), "a", pN);
        }
        else
            child = util.addNode(util.addNode(cObj, "li"), "span", pN);

        child.innerHTML = dV.value;

        if(dV.selected)// Falls allgem. Ärger macht: (isBlockNav || pgCountryDialog) 
            child.parentElement.className = "act";

        // clientAction if not native link
        if(!dV.aux[cc.cnst.aux_target])
            util.registerCE(dVId, "click", { ce: action });
    }
    return cObj;
}
// alle Content-Elemente, einschließlich evtl. Sections, rekursiv entfernen
AbstractSection.prototype.flushOut = function (suizide)
{
    if(this.sP)
    {
        util.recRemove(this.sP, suizide);
    }
    this.aux = {};
};
// Section-DOM-Element komplett entfernen
// this muss erhalten bleiben, da sonst nur nur die default-Funktionen wiederhergestellt werden!
AbstractSection.prototype.destroy = function ()
{
    this.flushOut(true);
    this.trace("error", "destroy()", this.id);
}
//this.trace("info", "init()",""); // z.B. Parametrierung überwachen: getCSV(this.id,this.type,this.src,this.width,this.height));

AbstractSection.prototype.trace = function trace(tKey, k, v) { cc.trace(tKey, this.id, k, v); };
AbstractSection.prototype.finalize = function () {};

// Section-Definition
// neue Section normalerweise, wenn ein neuer Key in der TargetList (tL) des jsO gefunden wird (C# - Visibility!)
// Sollen Methoden an Sections überschrieben werden, müssen diese explizit in func_sections.aspx angelegt werden!
function Section(id, c, ref)// type, src,w,h)
{
    this.id = id;
    this.sP = ref || null;
    this.aux = {};
}
Section.prototype = new AbstractSection();

/** 
* Default-DataObject-Auswertung: */
AbstractSection.prototype.evalData = function evalData(sEvt, dOs)
{
    // Ist die Funktion einer Section zugeordnet? (Darf sonst nicht gerufen werden! TODO: Begründung)//alert("!");
    if(typeof this.sP == "undefined")
        return false;
    var c;
    //debugger;
    for(var i = 0; i < dOs.length; i++)
    {
        var dObj = dOs[i];

        var sP = null;
        var pId = dObj.aux[cc.cnst.aux_parent];

        // wenn kein parent kommt oder parent nicht innerhalb this.sP liegt, muss der Section container genommen werden
        if(!pId || ((sP = cc.getAnchorCntrl(dObj.aux[cc.cnst.aux_topSection], pId)) && !this.sP.contains(sP)))
        {
            sP = this.sP;
        }
        // Fallback: Panels schreiben keine Anchor items
        if(!sP)
            sP = document.getElementById(util.getId(this.id, pId))
        if(!sP)
            cc.traceError("evalData()", "--- " + dObj.aux[cc.cnst.aux_topSection] + "." + pId + ": no sP! ---");

        // Gruppe registrieren?
        var grp = dObj.aux[cc.cnst.aux_group];
        if(grp)
        {
            if(!this.aux.groups)
            {
                this.aux.groups = {};
                this.aux.groupActions = {};
            }
            if(!this.aux.groups[grp]) this.aux.groups[grp] = [];
        }

        // Reset vCont (alle Container-Kinder löschen)
        if (dObj.aux[cc.cnst.aux_del])
        {
alert("Not yet implemented!");

            //cc.removeAnchorCntrl(dObj.aux[cc.cnst.aux_topSection], dObj.id);
        }

        // DOM node:
        var cObj = null;
        try
        {
            var cObj = document.getElementById(util.getId(this.id, dObj.id));

            // die eval-Funktionen können durch die Sections überschrieben werden
            switch(dObj.type)
            {
                case cc.cnst.dtp_action: cObj = this.evalLink(sP, dObj, cObj); break;
                case cc.cnst.dtp_actionLst: cObj = this.evalLinkList(sP, dObj, cObj); break;
                case cc.cnst.dtp_blockNav:
                    var dId = dObj.id;
                    dObj.id += "up";
                    cObj = document.getElementById(util.getId(this.id, dObj.id));
                    if(cObj)
                    {
                        // 1. über vCont
                        this.evalLinkList(sP.parentNode, dObj, cObj);
                        // 2.
                        dObj.id = dId + "dn";
                        this.evalLinkList(sP.parentNode, dObj, document.getElementById(util.getId(this.id, dObj.id)));
                    }
                    else
                    {
                        // 1. über vCont
                        cObj = this.evalLinkList(sP.parentNode, dObj, document.getElementById(util.getId(this.id, dObj.id)));
                        sP.parentNode.removeChild(cObj);
                        sP.parentNode.insertBefore(cObj, sP);
                        // 2.
                        dObj.id = dId + "dn";
                        this.evalLinkList(sP.parentNode, dObj, document.getElementById(util.getId(this.id, dObj.id)));
                    }
                    break;
                case cc.cnst.dtp_btn:
                    // evalBtn wertet target nicht aus (Bsp.: scan-Button)
                    if(dObj.aux[cc.cnst.aux_target])
                        cObj = AbstractSection.prototype.evalLink.call(this, sP, dObj, cObj);
                    else
                        cObj = this.evalBtn(sP, dObj, cObj);
                    break;
                case cc.cnst.dtp_chk: cObj = this.evalCheckbox(sP, dObj, cObj); break;
                case cc.cnst.dtp_cmd: break;
                case cc.cnst.dtp_combo: cObj = this.evalSelect(sP, dObj, cObj); break;
                case cc.cnst.dtp_dlg: cObj = this.evalDialog(sP, dObj, cObj); break;
                case cc.cnst.dtp_file: cObj = this.evalFile(sP, dObj, cObj); break;
                case cc.cnst.dtp_form: cObj = this.evalForm(sP, dObj, cObj); break;
                case cc.cnst.dtp_img: cObj = this.evalImg(sP, dObj, cObj); break;
                case cc.cnst.dtp_inp: cObj = this.evalInput(sP, dObj, cObj); break;
                case cc.cnst.dtp_menu: cObj = this.evalMenu(sP, dObj, cObj); break;
                //                case cc.cnst.dtp_node: cObj = this.evalLink(sP, dObj, cObj); break;       
                case cc.cnst.dtp_panel: cObj = this.evalPanel(sP, dObj, cObj); break;
                case cc.cnst.dtp_password: cObj = this.evalInput(sP, dObj, cObj); break;
                case cc.cnst.dtp_popUp: cObj = this.evalPopUp(sP, dObj, cObj); break;
                case cc.cnst.dtp_radio: cObj = this.evalRadioButton(sP, dObj, cObj); break;
                case cc.cnst.dtp_selAutoComplete: cObj = this.evalMatchBox(sP, dObj, cObj); break;
                case cc.cnst.dtp_swiper: cObj = this.evalSwiper(sP, dObj, cObj); break;
                case cc.cnst.dtp_tabCntrl: cObj = ("slider" == dObj.aux[cc.cnst.aux_inpType] ? this.evalSlidingTabCntrl(sP, dObj, cObj) : this.evalTabCntrl(sP, dObj, cObj)); break;
                case cc.cnst.dtp_tabHdr:
                case cc.cnst.dtp_tabRow:
                    // das werten nur TableSections + Ableitungen aus
                    if(typeof this.evalRows == "function")
                        this.evalRows(dObj, cObj);
                    break;
                case cc.cnst.dtp_togglePnl: cObj = this.evalTogglePanel(sP, dObj, cObj); break;
                case cc.cnst.dtp_txt: cObj = this.evalLink(sP, dObj, cObj); break;
                case cc.cnst.dtp_txtBox: cObj = this.evalTextBox(sP, dObj, cObj); break;
                case cc.cnst.dtp_txtLst: cObj = this.evalTextList(sP, dObj, cObj); break;
                case cc.cnst.dtp_view: cObj = this.evalViewPanel(sP, dObj, cObj); break;
                case cc.cnst.dtp_unknown: break;
                default:
                    this.trace("error", "evalData()", "Not evaluateted: " + dObj.type + " (" + dObj.id + ")");
                    /* Unknown, keine Id, keine desc + keine Kinder -> kein DOMObject
                    if(dObj.type==cc.cnst.dtp_Unknown && !dObj.desc && !dObj.id && dObj.dV && dObj.dV.length == 0)
                    continue;*/
                    if(!cObj)
                    {
                        // create:
                        cObj = util.addNode(sP, null, { id: util.getId(this.id, dObj.id) });
                        if(dObj.dV && dObj.dV.length > 0)
                        {
                            for(var j = 0; j < dObj.dV.length; j++)
                            {
                                var dV = dObj.dV[j];
                                var dVId = util.getId(this.id, dObj.id, dV.id);
                                var child = document.getElementById(dVId);
                                if(!child)
                                {
                                    child = util.addNode(util.addNode(cObj, "div"), dV.aux[cc.cnst.aux_action] != null ? "a" : "span", { id: dVId });
                                }
                                child.innerHTML = dV.value;
                                util.registerCE(dVId, "click", { ce: dV.aux[cc.cnst.aux_action] });
                            }
                        }
                        else
                            cObj.innerHTML = (dObj.desc || dObj.id || "-") + "(" + dObj.type + ")";
                    }
                    else
                    {
                        // update:
                    }
                    break;
            }
            if(cObj)
            {
                var invisible = !dObj.visible;
                if((invisible && !util.hasClass("visNone", cObj)) || (!invisible && util.hasClass("visNone", cObj)))
                    util.toggleClass("visNone", cObj);

                util.evictClass(dObj.aux[cc.cnst.aux_cssClear], cObj);
            }
            /*else
            this.trace("error", "evalData()", dObj.id + ": No return object!");*/

        } catch(ex) { this.trace("error", "evalData()", dObj.id + ": " + (ex.stack || ex.message)); }
    }
    this.finalize();
}
/**
* Aufbau allgemeines PANEL:
* Title, Inhalt (= Bild und/oder Linklist) (plus ggf. zusaetzlicher  Text, muss evtl. ueberarbeitet werden)
* Panel ist nicht auf- und zuklappbar
* Informationen kommen ueber ein DO
**/
AbstractSection.prototype.evalPanel = function evalPanel(sP, dObj, cObj)
{
    var pN = { id: util.getId(this.id, dObj.id), css: dObj.type.toLowerCase() };

    // Gruppe/ Sichtbarkeit
    sP = this.embedControl(sP, cObj, pN, dObj.aux[cc.cnst.aux_group], dObj.aux["title"], dObj.visible);
    if(cObj)
    { //was macht dieser Teil?
        // update -> killen + neu bauen?
        //debugger;
        util.recRemove(cObj);
    }
    else
        util.addClass("pCont", sP);

    // data: Bilder per Klick anzeigen, wenn es Bilder gibt
    cObj = util.getNode(sP, "div", pN); //Container fuer Title, Inhalt (Bild, Linklist) und Text

    // wenn Action, dann als Link darstellen
    if(dObj.aux["action"])
    {
        util.addNode(cObj, "a", { css: "title" }).innerHTML = dObj.desc;
        util.registerCE(pN.id, "click", { ce: dObj.aux["action"] });
    }
    //Title hinzufuegen, sonst gibt es nur das div (evtl. als Platzhalter?)
    else if(dObj.desc)
    {
        util.addNode(cObj, "span", { css: "title" }).innerHTML = dObj.desc;
        dObj.desc = null; // nicht doppelt!
    }
    //Bild hinzufuegen
    var j = 0, adds = null;
    if(dObj && dObj.imgLst)
    {
        var img = dObj.imgLst[0];
        if(img.height != "0")
        {
            cObj = util.getNode(cObj, "div", {});
            // Left ist 0 und top muss negativ sein!!!
            cObj.style.backgroundPosition = "0px -" + img.y + "px";
            cObj.style.backgroundImage = "url('" + img.src + "')";
            cObj.style.height = img.height + "px";
        }
        else
            // es ist nicht das div, was bei VAA den Abstand verursacht! evtl. img+png???
            util.addNode(util.addNode(cObj, "div", { css: "imgContainer" }), "img", { src: img.src, css: "" }); //image anlegen
            //util.addNode(cObj, "img", { src: img.src, css: "" }); //image ohne div anlegen?
        if(dObj.dV.length > 0)
        {
            adds = util.addNode(cObj, "div", {});
            adds.innerHTML = dObj.dV[0].value;
            dObj.dV.shift(); // nicht doppelt!
        }
    }
    // LinkList hinzufuegen
    if(dObj.dV.length > 0)
    {
        this.evalLinkList(cObj, dObj, null);
    }
    return cObj;
};

/**
* TogglePanel: kann gruppiert, geschachtelt, geöffnet und geschlossen werden
* Besteht aus div mit Title-Span (opt.), Container und ButtonList
**/
AbstractSection.prototype.evalTogglePanel = function evalTogglePanel(sP, dObj, cObj)
{
    var btnLst = null;
    if(!cObj)
    {
        // braucht das TogglePanel noch den Ident als css-Klasse: "+ dObj.id.toLowerCase()"?
        var pN = { id: util.getId(this.id, dObj.id), css: dObj.type.toLowerCase() }, p = null;

        // Gehört das Panel zu einer Group? Dann ist immer das selektiertierte offen, die anderen zu:
        var grp = dObj.aux[cc.cnst.aux_group];
        // wenn das Panel zu einer Gruppe gehört, muss es für den offenen Zustand selected sein, sonst ist es zu!
        // ohne Gruppe ist es immer auf!
        if((grp && dObj.selected) || !grp)
            util.joinClass(pN, cc.cnst.CSS_OPEN_GROUP);

        util.joinClass(pN, dObj.aux[cc.cnst.aux_css]);

        // view
        cObj = util.addNode(sP, "div", pN);
        cObj.style.width = this.width;
        cObj.style.height = this.height;

        // title
        if(dObj.desc || grp)
        {
            if(dObj.desc)
            {
                if(dObj.aux[cc.cnst.aux_addTxt])
                {
                    var tObj = util.addNode(cObj, "div", { css: "title" });
                    util.addNode(tObj, "span").innerHTML = dObj.desc;
                    util.addNode(tObj, "span", { css: "appendix" }).innerHTML = dObj.aux[cc.cnst.aux_addTxt];
                }
                else
                    util.addNode(cObj, "span", { css: "title" }).innerHTML = dObj.desc;
            }
            // Action, wenn es zur Gruppe gehört
            if(grp)
            {
                // cObj an Group-List
                this.aux.groups[grp][this.aux.groups[grp].length] = cObj;

                // Group am Element merken:
                cObj.setAttribute("data-group", grp);

                //Action fuer View-DropDown anlegen
                if(dObj.aux[cc.cnst.aux_action])
                    this.aux.groupActions[cObj.id] = { fn: util.createFN(dObj.aux[cc.cnst.aux_action]), once: false };
                var _this = this;
                var _beh = dObj.aux[cc.cnst.aux_groupBehavior];
                util.registerCE(cObj, "click", { fn: function (cObj) { _this.openGroup(cObj, _beh); } });
            }
        }

        // container:
        // container-Control in anchor-Liste eintragen, in dieser Liste ist es unerheblich, was der "anchor" für ein Control ist!
        p = util.addNode(cObj, "div", { css: "vCont" });
        cc.addAnchorCntrl(dObj.aux[cc.cnst.aux_topSection], dObj.id, p);

        // buttons:
        if(dObj.dV.length > 0)
        {
            btnLst = document.createElement("DIV");
            btnLst.className = "btnLst";
            cObj.appendChild(btnLst);
        }
    }
    else
    {
        // Reset vCont
        if(dObj.aux[cc.cnst.aux_del])
            util.recRemove(cObj.childNodes[1]);

        // description
        if(cObj.childNodes.length > 0 && cObj.childNodes[0].className == "title")
        {
            if(cObj.childNodes[0].tagName == "SPAN")
                cObj.childNodes[0].innerHTML = dObj.desc;
            else
            {
                cObj.childNodes[0].childNodes[0].innerHTML = dObj.desc;
                cObj.childNodes[0].childNodes[1].innerHTML = dObj.aux[cc.cnst.aux_addTxt]? dObj.aux[cc.cnst.aux_addTxt]: "";                
            }

        }

        // Selected-Zustand?
        if(dObj.selected3 != util.cmpVal.DC)
        {
            var isOpen = util.hasClass(cc.cnst.CSS_OPEN_GROUP, cObj);
            var isSelected = dObj.selected;
            if(isSelected && !isOpen)
            {
                this.openGroup(cObj);
                var _this = this;
                util.registerCE(cObj, "click", { fn: function (cObj) { _this.openGroup(cObj); } });
            }
            else if(!isSelected && isOpen)
            // wenn auf, dann zu
                util.toggleClass(cc.cnst.CSS_OPEN_GROUP, cObj);
        }
        // es kommen neue Kinder
        if(dObj.dV.length > 0)
        {
            btnLst = cObj.lastChild;
            if(dObj.aux[cc.cnst.aux_del])
                util.recRemove(btnLst);
        }
    }
    this.populateButtonList(btnLst, dObj);
    // kommt initial und bei Reset mit:
    if(dObj.aux[cc.cnst.aux_actionOnce])
        this.aux.groupActions[cObj.id] = { fn: util.createFN(dObj.aux[cc.cnst.aux_actionOnce]), once: true };
    return cObj;
}
/**
* View: kann gruppiert, geschachtelt, geöffnet und geschlossen werden
* Besteht aus div mit Title-Span (opt.), Container und ButtonList
**/
AbstractSection.prototype.evalViewPanel = function evalViewPanel(sP, dObj, cObj)
{
    var btnLst = null;
    if (!cObj)
    {
        var pN = { id: util.getId(this.id, dObj.id), css: dObj.type.toLowerCase() }, p = null;

        util.joinClass(pN, dObj.aux[cc.cnst.aux_css]);

        // view
        cObj = util.addNode(sP, "div", pN);

        // title
        if (dObj.desc || (this.isDlg && sP === this.sP))
            util.addNode(cObj, "span", { css: (this.isDlg ? "dlgTitle" : "title") }).innerHTML = dObj.desc || " ";


        // container:
        // container-Control in anchor-Liste eintragen, in dieser Liste ist es unerheblich, was der "anchor" für ein Control ist!
        p = util.addNode(cObj, "div", { css: "vCont" });
        cc.addAnchorCntrl(dObj.aux[cc.cnst.aux_topSection], dObj.id, p);

        // buttons:
        if (dObj.dV.length > 0)
            btnLst = util.addNode(cObj, "DIV", { css: "btnLst" });
    }
    else
    {
        // description?
        if (dObj.desc && cObj.childNodes[0].className == (this.isDlg ? "dlgTitle" : "title"))
        {
            cObj.childNodes[0].innerHTML = dObj.desc;
        }
        // Reset vCont
        if (dObj.aux[cc.cnst.aux_del])
            util.recRemove(cObj.childNodes[1]);

        // rebuild buttons
        if (dObj.dV.length > 0)
        {
            btnLst = cObj.lastChild;
            if (util.hasClass("btnLst", btnLst))
            {
                if (dObj.aux[cc.cnst.aux_del])
                    util.recRemove(btnLst);
            }
            else
                btnLst = util.addNode(cObj, "DIV", { css: "btnLst" });
        }
    }
    this.populateButtonList(btnLst, dObj);
    return cObj;
};
AbstractSection.prototype.evalTabCntrl = function evalTabCntrl(sP, dObj, cObj)
{
    // Text nur ändern, wenn einer mitkommt ( manchmal nur Buttonzustand ändern)
    var pN = { id: util.getId(this.id, dObj.id), css: dObj.type.toLowerCase() };
    cObj = util.getNode(sP, null, pN);
    // keep references
    if(!this.aux.refButtons)
    {
        this.aux.refButtons = {};
        this.aux.refPanels = {};
    }
    var btnLst = this.aux.refButtons[dObj.id] || (this.aux.refButtons[dObj.id] = util.getNode(cObj, "ul", { css: "tabLnkLst" }));
    var panelLst = this.aux.refPanels[dObj.id] || (this.aux.refPanels[dObj.id] = util.getNode(cObj, null, { css: "tabPanels" }));

    // Button-/ Panel-Liste:
    if(dObj.dV.length > 0)
    {
        for(var j = 0; j < dObj.dV.length; j++)
        {
            var dV = dObj.dV[j];
            var isDisabled = (typeof dV.aux[cc.cnst.aux_disabled] != "undefined");
            // Button
            var dVId = util.getId(pN.id, dV.id);
            var btn = document.getElementById(dVId);
            if(btn == null)
            {
                var s = dV.selected ? cc.cnst.CSS_SELECTED_TAB : isDisabled ? "dis" : dV.selected3 == util.cmpVal.DC && j == 0 ? cc.cnst.CSS_SELECTED_TAB : "";
                btn = util.addNode(util.addNode(btnLst, "li"), "a", { id: dVId, css: s });
                btn.innerHTML = dV.value;

                // Panel
                cc.addAnchorCntrl(dObj.aux[cc.cnst.aux_topSection], dV.id, util.addNode(panelLst, "div", { css: "tabPanel " + s })); // { id: dVId }
            }
            else
            {
                // state button/ panel?
                if(dV.selected3 != util.cmpVal.DC || (isDisabled && !util.hasClass("dis", btn)) || (!isDisabled && util.hasClass("dis", btn)))
                {
                    var s = dV.selected ? cc.cnst.CSS_SELECTED_TAB : isDisabled ? "dis" : "";
                    btn.className = s;
                    panelLst.childNodes[j].className = "tabPanel " + s;
                }
                btn.innerHTML = dV.value;
                // Reset
                if(dV.aux[cc.cnst.aux_del] || dObj.aux[cc.cnst.aux_del])
                    util.recRemove(panelLst.childNodes[j]);
            }
            util.addClass(dV.aux[cc.cnst.aux_css], btn);

            var _this = this;
            if(isDisabled)
                util.registerCE(btn, "click", { fn: [] });
            else
            {
                var fList = [function (cObj) { _this.toggleTabCntrl(cObj); } ];
                if(dV.aux[cc.cnst.aux_action])
                    fList[1] = util.createFN(dV.aux[cc.cnst.aux_action]);
                util.registerCE(btn, "click", { fn: fList });
            }
        }
    }
    else
    {
        // Reset
        if(dObj.aux[cc.cnst.aux_del])
            for(var j = 0; j < panelLst.childNodes.length; j++)
                util.recRemove(panelLst.childNodes[j]);
    }
    return cObj;
};
AbstractSection.prototype.evalSlidingTabCntrl = function (sP, dObj, cObj)
{
    // tabControl
    var pN = { id: util.getId(this.id, dObj.id), css: dObj.type.toLowerCase() };
    cObj = util.getNode(sP, null, pN);

    var swpCntrl = this.aux.swp && this.aux.swp[pN.id] || null;
    if (!swpCntrl)
    {
        if (!this.aux.swp)
            this.aux.swp = [];
        swpCntrl = new SwiperControl(this, cObj, dObj);
        this.aux.swp[swpCntrl.id] = swpCntrl;

        // cObj - tablnklst - swiper-wrapper
        //util.addClass("tabLnkLst", (cObj = document.getElementById(util.getId(swiper.id, dObj.id))));
        this.aux.root = cObj;//.parentNode.parentNode;
        // 
        //util.addClass("tabcontrol", this.aux.root);
        this.evalTabCntrlPanels(dObj, cObj);
    }
    else
    {
        //swiper.reset(dObj);
    }
};
AbstractSection.prototype.evalTabCntrlPanels = function evalTabCntrlPanel(dObj, cObj)
{
    // Text nur ändern, wenn einer mitkommt ( manchmal nur Buttonzustand ändern)
    // keep references
    if(!this.aux.refButtons)
    {
        this.aux.refButtons = {};
        this.aux.refPanels = {};
    }
    var panelLst = this.aux.refPanels[dObj.id] || (this.aux.refPanels[dObj.id] = util.getNode(this.aux.root, null, { css: "tabPanels" }));

    // Button-/ Panel-Liste:
    if(dObj.dV.length > 0)
    {
        for(var j = 0; j < dObj.dV.length; j++)
        {
            var dV = dObj.dV[j];
            var isDisabled = (typeof dV.aux[cc.cnst.aux_disabled] != "undefined");
            // Button
            var dVId = util.getId(cObj.id, dV.id);
            var btn = document.getElementById(dVId);

            var s = dV.selected ? " " + cc.cnst.CSS_SELECTED_TAB : isDisabled ? " dis" : dV.selected3 == util.cmpVal.DC && j == 0 ? " " + cc.cnst.CSS_SELECTED_TAB : ""; ;
            util.addClass(s, btn);

            // panel
            var pnl = panelLst.childNodes[j];
            if(!pnl)
            {
                pnl = util.addNode(panelLst, "div", { css: "tabPanel" + s });
                
                // Anker für tabPanel
                cc.addAnchorCntrl(dObj.aux[cc.cnst.aux_topSection], dV.id, pnl);
            }
            else
                pnl.className = "tabPanel" + s;

            // wenn selected, dann Anker für TabPanelControl setzen
            if(dV.selected)
                cc.addAnchorCntrl(dObj.aux[cc.cnst.aux_topSection], dObj.id, pnl);

            btn.innerHTML = dV.value;

            // Reset
            if(dV.aux[cc.cnst.aux_del] || dObj.aux[cc.cnst.aux_del])
                util.recRemove(panelLst.childNodes[j]);

            util.addClass(dV.aux[cc.cnst.aux_css], btn);
            util.evictClass(dV.aux[cc.cnst.aux_cssClear], btn);

            var _this = this;
            if(isDisabled)
                util.registerCE(btn, "click", { fn: [] });
            else
            {
                var fList = [function (cObj) { _this.toggleTabCntrl(cObj); } ];
                if(dV.aux[cc.cnst.aux_action])
                    fList[1] = util.createFN(dV.aux[cc.cnst.aux_action]);
                util.registerCE(btn, "click", { fn: fList });
            }
        }
    }
    else
    {
        // Reset
        if(dObj.aux[cc.cnst.aux_del])
            for(var j = 0; j < panelLst.childNodes.length; j++)
                util.recRemove(panelLst.childNodes[j]);
    }
    return cObj;
};

AbstractSection.prototype.evalForm = function evalForm(sP, dObj, cObj)
{
    // Text nur ändern, wenn einer mitkommt ( manchmal nur Buttonzustand ändern)
    if(cObj == null)
    {
        if (this.isDlg)
        {
            sP = cc.anchor[this.id] = util.addNode(sP, null, { css: "viewpanel" });

            // Überschrift in Dialogen
            if (dObj.desc)
                (util.addNode(sP, "span", { css: "dlgTitle" })).innerHTML = dObj.desc;
        }
        var pN = { id: util.getId(this.id, dObj.id), target: "", method: "POST" };
        if(dObj.aux[cc.cnst.aux_encrypt])
            pN[cc.cnst.aux_encrypt] = dObj.aux[cc.cnst.aux_encrypt];
        if(dObj.aux[cc.cnst.aux_target])
        {
            pN.target = dObj.aux[cc.cnst.aux_target];
            pN.action = dObj.aux[cc.cnst.aux_action];
        }
        var form = this.aux.form = util.getNode(sP, "form", pN);
        form.name = form.id;
        cc.addAnchorCntrl(dObj.aux[cc.cnst.aux_topSection], dObj.id, form);
        
        // Überschrift in Dialogen s.o.
        if (!this.isDlg && dObj.desc)
        {
            var s = dObj.aux[cc.cnst.aux_action];
            if(s != null && !pN.action)
            {
                child = util.addNode(form, "a");
                util.registerCE(pN.id, "click", { ce: dObj.aux[cc.cnst.aux_action] });
            }
            else
                child = util.addNode(form, "span", { css: "dlgTitle" });
            child.innerHTML = dObj.desc;
        }
        // ButtonListe:
        if(dObj.dV.length > 0)
        {
            //cObj = util.addNode(sP, "ul");
            cObj = util.addNode(sP, "div");
            cObj.className = "btnLst";
            this.populateButtonList(cObj, dObj, form);
        }
    }
    else
        util.getChildNodeByIdx(cObj, 0).innerHTML = dObj.desc;
    return cObj;
};

AbstractSection.prototype.evalBtn = function evalBtn(sP, dObj, cObj)
{
    if (!cObj)
    {
        // Gruppe registriert?
        var grp = dObj.aux[cc.cnst.aux_group];
        if (grp && this.aux.groups[grp].length == 1)
            sP = this.aux.groups[grp][0];        // zusätzliches FlexPanel
        var pN = { id: util.getId(this.id, dObj.id), css: dObj.type.toLowerCase() };
        util.joinClass(pN, dObj.aux[cc.cnst.aux_css]);

        cObj = util.addNode(sP, "a", pN);
    }
    cObj.innerHTML = dObj.desc || "";
    util.registerCE(cObj, "click", { ce: dObj.aux[cc.cnst.aux_action] });
};
Section.prototype.evalDialog = function (sP, dObj, cObj) { };

// Funktionalität für TogglePanels:
Section.prototype.openGroup = function openGroup(toggleElement, behavior)
{
    // Original-Status des geklickten Elements ermitteln
    var isOpen = util.hasClass(cc.cnst.CSS_OPEN_GROUP, toggleElement);
    var grp = toggleElement.getAttribute("data-group");

    // special case:
    if(isOpen && behavior == "NoAutoOpen")
    {
        util.toggleClass(cc.cnst.CSS_OPEN_GROUP, toggleElement);
        return;
    }

    //bereits geoeffnetes Panel schliessen, gibt max. eins:
    //aktuelle geklickte oder ein anderes offenes Panel  
    var all = this.aux.groups[grp]; //document.getElementsByClassName(className);

    // pedalMode (geht nur, wenn initial eins auf und eins zu ist!)
    if(all.length == 2)
    {
        // Berücksichtigen, wenn initial beide zu sind: das geklickte immer toggln, das andere nur, wenn es verschieden ist!
        var altElement = toggleElement === all[0] ? all[1] : all[0];
        // beide tauschen:
        if(util.hasClass(cc.cnst.CSS_OPEN_GROUP, altElement) != isOpen)
        {
            util.toggleClass(cc.cnst.CSS_OPEN_GROUP, all[0]);
            util.toggleClass(cc.cnst.CSS_OPEN_GROUP, all[1]);
            if(isOpen)
                toggleElement = altElement;
            // Ist das geklickte Element jetzt auf?
            isOpen = util.hasClass(cc.cnst.CSS_OPEN_GROUP, toggleElement);
        }
        else
        {
            // Nur den Zustand des geklickten Elements ändern
            isOpen = util.toggleClass(cc.cnst.CSS_OPEN_GROUP, toggleElement);
        }
    }
    else
    {
        for(var i = 0; i < all.length; i++)
            util.removeClass(cc.cnst.CSS_OPEN_GROUP, all[i]);

        //falls das geklickte, noch nicht offen war -> jetzt oeffnen
        if(!isOpen)
        {
            isOpen = util.toggleClass(cc.cnst.CSS_OPEN_GROUP, toggleElement);
        }
    }
    // das offene Panel hat eine Action -> DOs lösen das finalize() aus
    if(isOpen && this.aux.groupActions[toggleElement.id])
    {
        this.aux.groupActions[toggleElement.id].fn(toggleElement);
        
        // für einmalige Aktion -> Function zurücksetzen
        if(this.aux.groupActions[toggleElement.id].once == true)
            this.aux.groupActions[toggleElement.id] = null;
    }
    else
        // alles gerade rücken
        cc.adjustDimensions();
};

// Funktionalität für TabControls:
Section.prototype.toggleTabCntrl = function toggleTabCntrl(btn)
{
    // btn: Tab, auf den geklickt wurde, darf nicht der selektierte sein
    if(util.hasClass(cc.cnst.CSS_SELECTED_TAB, btn) || util.hasClass(cc.cnst.aux_disabled, btn))
        return false;

    // SwipeControl und normale Tabliste unterscheiden
    var btnLst, pnlLst, isSwpCntrl = (btn.parentNode.className == "swiper-wrapper");

    if(isSwpCntrl)
    {
        btnLst = btn.parentNode.childNodes;
        pnlLst = btn.parentNode.parentNode.parentNode.nextSibling;
    }
    else
    {
        btnLst = btn.parentNode.parentNode.childNodes;
        pnlLst = btn.parentNode.parentNode.nextSibling;
    }
    for(var i = 0; i < btnLst.length; i++)
    {
        var cBtn = isSwpCntrl ? btnLst[i] : btnLst[i].childNodes[0];
        var selected = cBtn.id == btn.id;
        util.toggleClass(cc.cnst.CSS_SELECTED_TAB, cBtn, selected);
        util.toggleClass(cc.cnst.CSS_SELECTED_TAB, pnlLst.childNodes[i], selected);
    }
};
Section.prototype.populateButtonList = function populateButtonList(btnLst, dObj, form)
{
    if (dObj.dV.length > 0 && btnLst)
    {
        var belongsToForm = (dObj.type == cc.cnst.dtp_form && form);
        for (var j = 0; j < dObj.dV.length; j++)
        {
            var dV = dObj.dV[j];
            var dVId = util.getId(this.id, dObj.id, dV.id);
            var pN = { id: dVId };
            var actions = null;
            if (dV.selected)
            {/*
                // aux_submit - Kennzeichen submit-Button
                // Value kann der Formularfeld-Ident sein, der dem Server sagt, welcher Button geklickt wurde;
                // hat das Formular nur einen Submit-Button, reicht "true" aus; */
                //var _itemId = dV.aux[cc.cnst.aux_submit];
                if (belongsToForm && (dV.aux[cc.cnst.aux_submit] || dV.id == "btnOk"))
                {
                    if (form.action)
                    {
                        // Button mit normaler Action + Form-Submit (extern!)
                        actions = { fn: [util.createFN(dObj.aux[cc.cnst.aux_action]), function () { form.submit(); }] };
                    }
                    else
                        // Form-Submit zum Server (intern)
                        actions = { fn: function (_itemId, _itemVal) { return function (cObj, evt) { if (_itemId && form.elements[_itemId]) form.elements[_itemId].value = _itemVal; cc.fireEvent("selectItem", form); } }(dV.aux[cc.cnst.aux_submit], dV.id) };
                }
                else if (dV.aux[cc.cnst.aux_target])
                {
                    // External link
                    pN.href = dV.aux[cc.cnst.aux_action];
                    pN.target = dV.aux[cc.cnst.aux_target];
                }
                else if (dV.aux[cc.cnst.aux_msg])
                {
                    // Mail link
                    pN.href = "mailto:?subject=" + dV.aux[cc.cnst.aux_title] + "&body=" + dV.aux[cc.cnst.aux_msg];
                }
                else
                    actions = { ce: dV.aux[cc.cnst.aux_action] };
                if (actions)
                {
                    if (this.isDlg && dV.aux[cc.cnst.aux_defBtn])
                    {
                        // Hier noch keinen Focus setzen, das blockiert evtl. Inputfelder!
                        // Falls der def-Button fokussiert werden soll, 
                        // dann hier "defBtn"-Klasse dazu und in setNextFocus-Fkt. auswerten, wenn alles durch ist!
                        util.registerCE(this.sP, "enter", actions);
                    }
                    util.registerCE(dVId, "click", actions);
                }
            }
            else
                pN.css = "dis";

            util.joinClass(pN, dV.aux[cc.cnst.aux_css]);
            var cObj = util.getNode(btnLst, "a", pN);
            if (util.hasClass("dis", cObj) !== !dV.selected)
            {
                util.toggleClass("dis", cObj, !dV.selected);
            }
            cObj.innerHTML = dV.value;
        }
        // nur für Dialoge
        if (this.isDlg)
            this.addCloseButton(dObj.dV);
    }
};
/* Tooltip-Icon (nach Eingabe-Controls) */
Section.prototype.evalTT = function evalTT(sP, dObj)
{
    if (dObj.aux[cc.cnst.aux_tt])
    {
        // Wrapper dazu, damit das Icon immer ganz hinten steht
        sP = util.addNode(sP, "div", { css: "wrp" });
        if (dObj.aux[cc.cnst.aux_group])
            this.aux.groups[dObj.aux[cc.cnst.aux_group]][0] = sP;

        // Panel:
        var ttPnl = util.getNode(this.sP, "div", { id: dObj.id + "_pnl", css: "popUp" });
        ttPnl.innerHTML = dObj.aux[cc.cnst.aux_tt];
        // Button:
        var ttBtn = util.addNode(sP.parentNode, "span", { id: dObj.id + "_tt", css: "tt" });
        if (!this.isDlg)
        {
            ttPnl.style.top = (this.sP.offsetHeight - 5) + "px";
        }
        var _this = this;
        util.registerCE(ttBtn, "click", {
            fn: (function (pnl)
            {
                return function showTT(btn, cEvt)
                {
                    //Status toggeln
                    var status = util.toggleClass(cc.cnst.CSS_OPEN_GROUP, pnl);
                    if (status)
                    {
                        // Beim Öffnen: Position zunächst in grober Näherung
                        if (_this.isDlg)
                        {
                            pnl.style.width = (parseFloat(util.getStyleProperty("width", pnl.parentNode)) - 26) + "px";
                            // .pageY ist der Abstand zum Fenster-Nullpunkt (.clientY ist der Abstand zum Viewport-NP -> funktioniert nicht für IPhone!)
                            pnl.style.top = (cEvt.pageY - (pnl.parentNode.offsetTop + pnl.offsetHeight + 20)) + "px";
                        }
                        //                    else
                        //                    {
                        //                        debugger;
                        //                    }
                        util.registerFlyout(btn, null);
                    }
                    cc.traceError("showTT()", btn.id + (status ? " -> " + pnl.style.width + "/ " + pnl.style.top : ""));
                }
            })(ttPnl)
        });
    }
    return sP;
};
/* Wenn sich die Editierbarkeit eines Feldes ändert, muss auch das Label entspr. angepasst werden */
AbstractSection.prototype.checkChangeability = function (pnl, cObj, isEditable)
{
    if (cObj)
    {
        // input-Felder nicht disablen:
        // - werden sonst nicht gepostet
        // - im FF kann der Textarea-Inhalt nicht kopiert werden
        if (cObj.tagName == "INPUT") // && (cObj.type == "text" || cObj.type == "hidden"))
        {
            if (isEditable)
                cObj.removeAttribute("readonly");
            else
                cObj.setAttribute("readonly", "readonly");
        }
        else
        {
            // Bei Comboboxen wirkt readonly nicht (IE11)!
            if (isEditable)
                cObj.removeAttribute("disabled");
            else
                cObj.setAttribute("disabled", "disabled");
        }
        // für disabled label "disabled"-Klasse an parent (Sollte schöner gehen!)
        if (pnl && ((util.hasClass("formItem", pnl) || util.hasClass("checkbox", pnl) || util.hasClass("radiobutton", pnl)) || ((pnl = pnl.parentNode) && util.hasClass("formItem", pnl))))
            util.toggleClass("disabled", pnl, !isEditable);
    }
};
